package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidPayModeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAddressException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableBankException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCardException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;

public class AgencyUpdater extends SaveAdapter {

	public Serializable save(HashMap map) {

		try {

			if (inputTesting(map))				
				
			AgencyController.updateAgency((Long) map.get("id"), (Long) map.get("address"), (String) map.get("street"), (String) map.get("dwellingPlace"), 
					(String) map.get("phone1"), (String) map.get("phone2"), (String) map.get("fax"), (String) map.get("email"), (String) map.get("web"), (Long) map.get("bank"), (Long) map.get("card"), (String) map.get("notes"), 
					(String) map.get("cif"), (String) map.get("name"), (String) map.get("contact"), (String) map.get("payMode"), (String) map.get("accountNumber"), 
					(String) map.get("cardNumber"));
		
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
		} catch (UnaceptableAddressException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));		
		} catch (UnaceptableBankException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("bank"));
		} catch (UnaceptableCardException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("card"));		
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		}  catch (InternalErrorException e) {			
			e.printStackTrace();
		}
		return (Long) map.get("id");
	}

	protected boolean inputTesting(HashMap map) {
		
		if (((Long) map.get("address")) == null) {		
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));
			return false;
		}

		if (((String) map.get("name")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("name"));
			return false;
		}				
		
		if (((String) map.get("cif")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("cif"));
			return false;
		}
		
		ErrorsHandler.clear();

		return true;

	}

}
