package gz.cyberbrain.cyberhotel.controller;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JPanel;

import gz.cyberbrain.cyberhotel.model.bank.to.BankTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BankWithClientsException;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.ImageItem;

public class BankController {

	private static ConfigurationFacadeDelegate delegate = SpringFacadeFactory.getConfigurationFacadeDelegate();
	private static HashMap<String, String> attributes = new HashMap<String, String>();

	private BankController() {}

	public static Vector bankList() throws InternalErrorException {				
		Vector<JPanel> items = new Vector<JPanel>();
		Collection banks = delegate.showBanks();
		Iterator iter = banks.iterator();

		BankTo bank;

		for (int i=0; iter.hasNext(); i++) {

			bank = (BankTo) iter.next();
			items.add(new ImageItem(bank.getBankId(), bank.getName(), bank.getLogo()));

		}

		return items;
	}

	public static Serializable createBank(String name, String logo) throws InternalErrorException {
		return delegate.createBank(new BankTo(null, name, logo)).getBankId();
	}
	
	public static void updateBank(Long bankId, String name, String logo) throws InternalErrorException {
		delegate.updateBank(new BankTo(bankId, name, logo));
	}

	public static void deleteBank(Long bankId) throws InstanceNotFoundException, BankWithClientsException, InternalErrorException{
		BankTo bank = delegate.findBank(bankId);
		delegate.deleteBank(bank);
	}
	
	public static HashMap findBank(Long bankId) throws InstanceNotFoundException, InternalErrorException {
		BankTo bank = delegate.findBank(bankId);
		
		attributes.put("name", bank.getName());
		attributes.put("logo", bank.getLogo());
		
		return attributes;
				
	}
}