package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.model.card.to.CardTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.CardWithClientsException;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.ImageItem;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JPanel;

public class CardController {

	private static ConfigurationFacadeDelegate delegate = SpringFacadeFactory.getConfigurationFacadeDelegate();
	private static HashMap<String, String> attributes = new HashMap<String, String>();
	
	private CardController() {}
	
	public static Vector cardList() throws InternalErrorException {				
		Vector<JPanel> items = new Vector<JPanel>();
		Collection cards = delegate.showCards();
		Iterator iter = cards.iterator();

		CardTo card;

		for (int i=0; iter.hasNext(); i++) {

			card = (CardTo) iter.next();
			items.add(new ImageItem(card.getCardId(), card.getType(), card.getLogo()));

		}

		return items;
	}

	public static Serializable createCard(String name, String logo) throws InternalErrorException {
		return delegate.createCard(new CardTo(null, name, logo)).getCardId();
	}

	public static void updateCard(Long cardId, String name, String logo) throws InternalErrorException {
		delegate.updateCard(new CardTo(cardId, name, logo));
	}
	
	public static void deleteCard(Long cardId) throws InstanceNotFoundException, CardWithClientsException, InternalErrorException{
		CardTo card = delegate.findCard(cardId);
		delegate.deleteCard(card);
	}
	
	public static HashMap findCard(Long cardId) throws InstanceNotFoundException, InternalErrorException {
		CardTo card = delegate.findCard(cardId);
		
		attributes.put("name", card.getType());
		attributes.put("logo", card.getLogo());
		
		return attributes;
				
	}
	
}
