package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.CompanyWithReservationsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class CompanyListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new CompanyCreator();
	}
	
	public SaveAdapter getUpdater() {
		return new CompanyUpdater();
	}
	
	public Vector load() {
		Vector list = new Vector();

		try {
			list = CompanyController.companyList();
		} catch (InternalErrorException e) {}

		return list;
	}
	
	public void delete(Serializable id) {

		try {
			CompanyController.deleteCompany((Long) id);
		} catch (InstanceNotFoundException e) {		
		} catch (InternalErrorException e) {
		} catch (CompanyWithReservationsException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (ClientPayerException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (ClientWithInvoicesException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = CompanyController.findCompany((Long) id);
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
        } catch (InternalErrorException e) {
        	e.printStackTrace();
        }
        return map;
	}
}
