package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.model.concept.to.ConceptTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.ConceptInUseException;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.util.money.MoneyOperations;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

public class ConceptController {

	private static ConfigurationFacadeDelegate delegate = SpringFacadeFactory.getConfigurationFacadeDelegate();
	private static HashMap<String, Object> attributes = new HashMap<String, Object>();

	private ConceptController() {}

	public static Vector conceptList()  {				
		Vector<TextItem> items = new Vector<TextItem>();
		Collection concepts;
		try {
			concepts = delegate.showConcepts();

			Iterator iter = concepts.iterator();
			ConceptTo concept;

			for (int i=0; iter.hasNext(); i++) {

				concept = (ConceptTo) iter.next();
				items.add(new TextItem(concept.getConceptCode(), concept.getDenomination()));

			}

		} catch (InternalErrorException e) {
			e.printStackTrace();
		}

		return items;
	}

	public static Serializable createConcept(String conceptCode, String denomination, BigDecimal vat) throws InternalErrorException {
		return delegate.createConcept(new ConceptTo(conceptCode, denomination, vat)).getConceptCode();
	}

	public static void updateConcept(String conceptCode, String denomination, BigDecimal vat) throws InternalErrorException {
		delegate.updateConcept(new ConceptTo(conceptCode, denomination, vat));
	}

	public static void deleteConcept(String conceptCode) throws InstanceNotFoundException, ConceptInUseException, InternalErrorException{
		ConceptTo concept = delegate.findConcept(conceptCode);
		delegate.deleteConcept(concept);
	}

	public static HashMap findConcept(String conceptCode) throws InstanceNotFoundException, InternalErrorException {
		ConceptTo concept = delegate.findConcept(conceptCode);

		attributes.put("code", concept.getConceptCode());
		attributes.put("denomination", concept.getDenomination());
		attributes.put("vat", MoneyOperations.getDecimalReduction(concept.getVat()));

		return attributes;

	}

}
