package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ParticularWithOwesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ParticularWithReservationsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class ParticularListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new ParticularCreator();
	}

	public SaveAdapter getUpdater() {
		return new ParticularUpdater();
	}

	public Vector load() {
		Vector list = new Vector();

		list = ParticularController.particularList();

		return list;
	}

	public void delete(Serializable id) {

		try {
			ParticularController.deleteParticular((Long) id);
		} catch (InstanceNotFoundException e) {		
		} catch (InternalErrorException e) {
		} catch (ParticularWithOwesException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (ParticularWithReservationsException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (ClientPayerException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (ClientWithInvoicesException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = ParticularController.findParticular((Long) id);
		} catch (InstanceNotFoundException e) {
		} catch (InternalErrorException e) {}
		return map;
	}

}
