package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomWithBoardersException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class RoomListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new RoomCreator();
	}

	public SaveAdapter getUpdater() {
		return new RoomUpdater();
	}

	public Vector load() {
		Vector list = new Vector();

		list = RoomController.roomList();

		return list;
	}

	public void delete(Serializable id) {

		try {
			RoomController.deleteRoom((String) id);
		} catch (InstanceNotFoundException e) {
		} catch (RoomWithBoardersException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InternalErrorException e) {
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = RoomController.findRoom((String) id);
		} catch (InstanceNotFoundException e) {
		} catch (InternalErrorException e) {}
		return map;
	}

}
