package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomTypeInUseException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class RoomTypeListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new RoomTypeCreator();
	}
	
	public SaveAdapter getUpdater() {
		return new RoomTypeUpdater();
	}
	
	public Vector load() {
		Vector list = new Vector();

		try {
			list = RoomTypeController.roomTypeList();
		} catch (InternalErrorException e) {}

		return list;
	}
	
	public void delete(Serializable id) {

		try {
			RoomTypeController.deleteRoomType((String) id);
		} catch (InstanceNotFoundException e) {
		} catch (RoomTypeInUseException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InternalErrorException e) {
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = RoomTypeController.findRoomType((String) id);
		} catch (InstanceNotFoundException e) {
        } catch (InternalErrorException e) {}
        return map;
	}

}
