package gz.cyberbrain.cyberhotel.model.address.dao;

import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface AddressDao {

	public AddressTo create(AddressTo addressTo) throws InternalErrorException;

	public AddressTo find(Long addressId) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (AddressTo addressTo) 
		throws InternalErrorException;
	
	public void remove(AddressTo addressTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findCountries() throws InternalErrorException;
	
	public Collection findProvincesByCountry(String country) throws InternalErrorException;
	
	public Collection findLocalitiesByProvince(String country, String province) throws InternalErrorException;
	
	public Collection findByCountry(String country) throws InternalErrorException;
	
	public Collection findByProvince(String country, String province) throws InternalErrorException;
	
	public AddressTo findByLocality(String country, String province, String locality) throws InstanceNotFoundException, InternalErrorException;
	
	public AddressTo findByCompleteAddress(String country, String province, String locality) throws InstanceNotFoundException, InternalErrorException;
	
	public boolean existClients (Long addressId, String country) 
		throws InternalErrorException;
	
}
