package gz.cyberbrain.cyberhotel.model.bank.dao;

import gz.cyberbrain.cyberhotel.model.bank.to.BankTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class BankSpringDao extends AbstractSpringDao implements BankDao{

	public BankSpringDao() {
		super(BankTo.class);
	}	

	public BankTo create(BankTo bankTo) throws InternalErrorException {		

		return (BankTo) super.save(bankTo);

	}

	public BankTo find(Long bankId) throws InstanceNotFoundException, InternalErrorException {

		BankTo bankTo = (BankTo) super.find(bankId);
		return bankTo;

	}

	public void update(BankTo bankTo) throws InternalErrorException {		

		super.update(bankTo);

	}

	public void remove(BankTo bankTo) throws InternalErrorException {

			super.delete(bankTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allBanks";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existClients(Long bankId) throws InternalErrorException {
		String queryName = "bankClients";
		return (!super.findByAttribute(queryName, bankId).isEmpty());
	}
	
}
