package gz.cyberbrain.cyberhotel.model.board.dao;

import gz.cyberbrain.cyberhotel.model.board.to.BoardTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class BoardSpringDao extends AbstractSpringDao implements BoardDao {

	public BoardSpringDao() {
		super(BoardTo.class);
	}	

	public BoardTo create(BoardTo boardTo) throws InternalErrorException {		

		return (BoardTo) super.save(boardTo);

	}

	public BoardTo find(String boardCode) throws InstanceNotFoundException, InternalErrorException {

		BoardTo boardTo = (BoardTo) super.find(boardCode);
		return boardTo;
		
	}

	public void update(BoardTo boardTo) throws InternalErrorException {		

		super.update(boardTo);

	}

	public void remove(BoardTo boardTo) throws InternalErrorException {

			super.delete(boardTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allBoards";
		return super.findByQuery(queryName);
		
	}
	
	public Collection findAllCodes() throws InternalErrorException {
		
		String queryName = "allBoardCodes";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existRequests(String boardCode) throws InternalErrorException {
		String queryName = "boardRequests";
		return (!super.findByAttribute(queryName, boardCode).isEmpty());
	}
	
	public boolean isTariffied(String boardCode) throws InternalErrorException {
		String queryName = "boardPrices";
		return (!super.findByAttribute(queryName, boardCode).isEmpty());
	}
	
}
