package gz.cyberbrain.cyberhotel.model.card.dao;

import gz.cyberbrain.cyberhotel.model.card.to.CardTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface CardDao {

	public CardTo create(CardTo cardTo) throws InternalErrorException;

	public CardTo find(Long cardId) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (CardTo cardTo) 
		throws InternalErrorException;
	
	public void remove(CardTo cardTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public boolean existClients (Long cardId) throws InternalErrorException;
	
}
