package gz.cyberbrain.cyberhotel.model.client.dao;

import gz.cyberbrain.cyberhotel.model.client.to.AgencyTo;
import gz.cyberbrain.cyberhotel.model.client.to.ClientTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;
import java.util.Vector;

public class AgencySpringDao extends AbstractSpringDao implements ClientDao {

	public AgencySpringDao() {
		super(AgencyTo.class);
	}	

	public AgencyTo create(ClientTo agencyTo) throws InternalErrorException {		

		return (AgencyTo) super.save(agencyTo);

	}

	public ClientTo find(Long clientId) throws InstanceNotFoundException, InternalErrorException {

		ClientTo clientTo = (ClientTo) super.find(clientId);
		return clientTo;

	}

	public void update(ClientTo agencyTo) throws InternalErrorException {		

		super.update(agencyTo);

	}

	public void remove(ClientTo agencyTo) throws InternalErrorException {

		super.delete(agencyTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allAgencies";
		return super.findByQuery(queryName);

	}

	public Collection findAllIds() throws InternalErrorException {

		String queryName = "allAgencyIds";
		return super.findByQuery(queryName);
	}

	public Collection findByKeys (Vector keys) throws InternalErrorException {

		String queryString = "from AgencyTo as agency where";

		for (int i=0;i<keys.size();i++)
			if(i==keys.size()-1)
				queryString += " agnecy.name like "+ (String) keys.get(i);
			else
				queryString += " agency.name like " + (String) keys.get(i) + " and";

		return super.findByQuery(queryString);

	}

	public boolean existOwes(Long clientId) throws InternalErrorException {
		return false;
	}

	public boolean existRequests(Long clientId) throws InternalErrorException {
		return false;
	}

	public boolean isPayer (Long clientId) throws InternalErrorException {
		String queryName = "clientPayments";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}

	public boolean existInvoices(Long clientId) throws InternalErrorException {
		String queryName = "clientInvoices";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}
	
	public boolean takesPartInReservation(Long clientId) throws InternalErrorException {
		String queryName = "agencyReservations";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}
	
}
