package gz.cyberbrain.cyberhotel.model.client.dao;

import gz.cyberbrain.cyberhotel.model.client.to.ClientTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;
import java.util.Vector;

public interface ClientDao {

	public ClientTo create(ClientTo clientTo) throws InternalErrorException;

	public ClientTo find(Long clientId) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (ClientTo clientTo) throws InternalErrorException;
	
	public void remove(ClientTo clientTo) throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findAllIds() throws InternalErrorException;
	
	public Collection findByKeys(Vector keys) throws InternalErrorException;
	
	public boolean existOwes(Long clientId) throws InternalErrorException;
	
	public boolean takesPartInReservation(Long clientId) throws InternalErrorException;
	
	public boolean existRequests(Long clientId) throws InternalErrorException;
	
	public boolean isPayer (Long clientId) throws InternalErrorException;
	
	public boolean existInvoices(Long clientId) throws InternalErrorException;
	
}
