package gz.cyberbrain.cyberhotel.model.concept.dao;

import gz.cyberbrain.cyberhotel.model.concept.to.ConceptTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class ConceptSpringDao extends AbstractSpringDao implements ConceptDao {

	public ConceptSpringDao() {
		super(ConceptTo.class);
	}	

	public ConceptTo create(ConceptTo conceptTo) throws InternalErrorException {		

		return (ConceptTo) super.save(conceptTo);

	}

	public ConceptTo find(String conceptCode) throws InstanceNotFoundException, InternalErrorException {

		ConceptTo conceptTo = (ConceptTo) super.find(conceptCode);
		return conceptTo;

	}

	public void update(ConceptTo conceptTo) throws InternalErrorException {		

		super.update(conceptTo);

	}

	public void remove(ConceptTo conceptTo) throws InternalErrorException {

			super.delete(conceptTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allConcepts";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existOwes(String conceptCode) throws InternalErrorException {
		
		String queryName = "conceptOwes";
		return (!super.findByAttribute(queryName, conceptCode).isEmpty());
		
	}
	
}
