package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.board.dao.BoardDao;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableBoardException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableSeasonException;
import gz.cyberbrain.cyberhotel.model.price.dao.PriceDao;
import gz.cyberbrain.cyberhotel.model.price.to.PriceTo;
import gz.cyberbrain.cyberhotel.model.pricetype.dao.PriceTypeDao;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptablePriceTypeException;
import gz.cyberbrain.cyberhotel.model.season.dao.SeasonDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class CreatePriceAction {

	private PriceTo priceTo;
	private BoardDao boardDao;
	private PriceTypeDao priceTypeDao;
	private SeasonDao seasonDao;
	private PriceDao priceDao;
	
	public CreatePriceAction(PriceTo priceTo, BoardDao boardDao, PriceTypeDao priceTypeDao, SeasonDao seasonDao, PriceDao priceDao) {
		
		this.priceTo = priceTo;
		this.boardDao = boardDao;
		this.priceTypeDao = priceTypeDao;
		this.seasonDao = seasonDao;
		this.priceDao = priceDao;
		
	}
	
	public void execute() 
	throws UnaceptablePriceTypeException, UnaceptableBoardException, 
	UnaceptableSeasonException, InternalErrorException {
		
		try {
			boardDao.find(priceTo.getBoard());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableBoardException(priceTo.getBoard());
		}
		
		try {
			priceTypeDao.find(priceTo.getPriceType());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptablePriceTypeException(priceTo.getPriceType());
		}
		
		try {
			seasonDao.find(priceTo.getSeason());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableSeasonException(priceTo.getSeason());
		}
		
		priceDao.create(priceTo);
		
	}

}
