package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.bank.dao.BankDao;
import gz.cyberbrain.cyberhotel.model.bank.to.BankTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BankWithClientsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteBankAction {

	private BankTo bankTo;
	private BankDao bankDao;
	
	public DeleteBankAction (BankTo bankTo, BankDao bankDao) {
		
		this.bankTo = bankTo;
		this.bankDao = bankDao;
		
	}
	
	public void execute() throws BankWithClientsException, InternalErrorException {
		
		if (bankDao.existClients(bankTo.getBankId())) throw new BankWithClientsException(bankTo);
		
		bankDao.remove(bankTo);
		
	}
}
