package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.board.dao.BoardDao;
import gz.cyberbrain.cyberhotel.model.board.to.BoardTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BoardInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BoardTariffiedException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteBoardAction {

	private BoardTo boardTo;
	private BoardDao boardDao;
	
	public DeleteBoardAction (BoardTo boardTo, BoardDao boardDao) {
		
		this.boardTo = boardTo;
		this.boardDao = boardDao;
		
	}
	
	public void execute() throws BoardInUseException, BoardTariffiedException, InternalErrorException {
		
		if (boardDao.existRequests(boardTo.getBoardCode())) throw new BoardInUseException(boardTo);
		if (boardDao.isTariffied(boardTo.getBoardCode())) throw new BoardTariffiedException(boardTo);
				
		boardDao.remove(boardTo);			
		
	}
	
}
