package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomWithBoardersException;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteRoomAction {

	private RoomTo roomTo;
	private RoomDao roomDao;
	
	public DeleteRoomAction (RoomTo roomTo, RoomDao roomDao) {
		
		this.roomTo = roomTo;
		this.roomDao = roomDao;
		
	}
	
	public void execute() throws RoomWithBoardersException, InternalErrorException {
		
		if (roomDao.existBoarders(roomTo.getRoomCode())) throw new RoomWithBoardersException(roomTo);
		
		roomDao.remove(roomTo);
		
	}
	
}
