package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UserInUseException;
import gz.cyberbrain.cyberhotel.model.user.dao.UserDao;
import gz.cyberbrain.cyberhotel.model.user.to.UserTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class RemoveUserAction {

	private UserTo userTo;
	private UserDao userDao;

	public RemoveUserAction (UserTo userTo, UserDao userDao) {

		this.userTo = userTo;
		this.userDao = userDao;

	}

	public void execute() throws UserInUseException, InternalErrorException {

		if (userDao.hasAssociatedItems(userTo.getLogin())) throw new UserInUseException(userTo);

		userDao.remove(userTo);


	}

}