package gz.cyberbrain.cyberhotel.model.request.dao;

import gz.cyberbrain.cyberhotel.model.request.to.RequestTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;

public class RequestSpringDao extends AbstractSpringDao implements RequestDao {

	public RequestSpringDao() {
		super(RequestTo.class);
	}	

	public RequestTo create(RequestTo requestTo) throws InternalErrorException {		

		return (RequestTo) super.save(requestTo);

	}

	public RequestTo find(Long reservationId, Long clientId) throws InstanceNotFoundException, InternalErrorException {

		String queryName = "aRequest";
		Serializable []attributes = {reservationId, clientId}; 
		Collection requestTo = super.findByAttributes(queryName, attributes);

		Exception e = new Exception("Request must be unique");

		if (requestTo.size() > 1) throw new InternalErrorException(e);
		if (requestTo.isEmpty()) throw new InstanceNotFoundException(attributes,RequestTo.class.getName());

		Iterator iter = requestTo.iterator();

		return (RequestTo) iter.next();

	}

	public void update(RequestTo requestTo) throws InternalErrorException {		

		super.update(requestTo);

	}

	public void remove(RequestTo requestTo) throws InternalErrorException {

			super.delete(requestTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allRequests";
		return super.findByQuery(queryName);
		
	}
	
}
