package gz.cyberbrain.cyberhotel.model.reservation.dao;

import gz.cyberbrain.cyberhotel.model.reservation.to.ReservationTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public interface ReservationDao {

	public ReservationTo create(ReservationTo reservationTo) throws InternalErrorException;

	public ReservationTo find(Long reservationId) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (ReservationTo reservationTo) 
		throws InternalErrorException;
	
	public void remove(ReservationTo reservationTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findByStatus(String reservationStatus) 
		throws InternalErrorException;
	
	public Collection findByDates(Calendar []attributes) throws InternalErrorException;
	
	public Collection findRequests(Long reservationId) throws InternalErrorException;
	
	public Collection findReservationOwes(Long reservationId) throws InternalErrorException;
	
}
