package gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions;

import gz.cyberbrain.cyberhotel.model.util.exceptions.ModelException;

public class UnaceptableInvoiceException extends ModelException {

	private static final long serialVersionUID = -953276916342748821L;
	private Long invoiceNumber;
	private String invoiceSerial;
	
	public UnaceptableInvoiceException (Long invoiceNumber, String invoiceSerial) {
		
		super ("Invoice " + invoiceNumber + "/" + invoiceSerial + " is not in database.");
		this.invoiceNumber = invoiceNumber;
		this.invoiceSerial = invoiceSerial;
	}
	
	public Long getInvoiceNumber() {
		return invoiceNumber;
	}
	
	public String getInvoiceSerial() {
		return invoiceSerial;
	}
	
}
