package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.reservation.dao.ReservationDao;
import gz.cyberbrain.cyberhotel.model.reservation.to.ReservationTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class FindACheckOutAction {

	private Long reservationId;
	private ReservationDao reservationDao;

	public FindACheckOutAction(Long reservationId, ReservationDao reservationDao) {
		this.reservationId = reservationId;
		this.reservationDao = reservationDao;
	}
	
	public ReservationTo execute() throws InstanceNotFoundException, InternalErrorException {
		
		ReservationTo reservation = reservationDao.find(reservationId);
		
		if (!reservation.getReservationStatus().equals("Finalizada")) 
			throw new InstanceNotFoundException(reservationId, reservation.getClass().getName());
		
		return reservation;
		
	}
	
}
