package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.bank.dao.BankDao;
import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.client.to.CompanyTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAddressException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableBankException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class InsertACompanyAction {

	private CompanyTo companyTo;
	private AddressDao addressDao;
	private BankDao bankDao;
	private ClientDao companyDao;

	public InsertACompanyAction (CompanyTo companyTo, AddressDao addressDao, BankDao bankDao, ClientDao companyDao) {
		this.companyTo = companyTo;
		this.addressDao = addressDao;
		this.bankDao = bankDao;
		this.companyDao = companyDao;
	}

	public CompanyTo execute() 
	throws UnaceptableAddressException, UnaceptableBankException, InternalErrorException {

		try {
			addressDao.find(companyTo.getAddress());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableAddressException(companyTo.getAddress());
		}

		try {
			bankDao.find(companyTo.getBank());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableBankException(companyTo.getBank());
		}

		//Companies dont work with cards

		/*CardDao cardDao = SpringDaoFactory.getCardDao();

		try {
			cardDao.find(companyTo.getCard());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableCardException(companyTo.getCard());
		}*/
		
		return (CompanyTo) companyDao.create(companyTo);

	}

}
