package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.client.to.CompanyTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.CompanyWithReservationsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class RemoveACompanyAction {
	
	private CompanyTo companyTo;
	private ClientDao companyDao;
	
	public RemoveACompanyAction(CompanyTo companyTo, ClientDao companyDao) {
		this.companyTo = companyTo;
		this.companyDao = companyDao;
	}
	
	public void execute() 
		throws CompanyWithReservationsException, ClientPayerException, 
		ClientWithInvoicesException, InternalErrorException {
		
		if (companyDao.takesPartInReservation(companyTo.getClientId()))
			throw new CompanyWithReservationsException(companyTo);
		
		if (companyDao.isPayer(companyTo.getClientId()))
			throw new ClientPayerException(companyTo);
		
		if (companyDao.existInvoices(companyTo.getClientId()))
			throw new ClientWithInvoicesException(companyTo);
		
		companyDao.remove(companyTo);
		
	}
	
}
