package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import java.util.Collection;
import java.util.Iterator;

import gz.cyberbrain.cyberhotel.model.request.dao.RequestDao;
import gz.cyberbrain.cyberhotel.model.request.to.RequestTo;
import gz.cyberbrain.cyberhotel.model.reservation.dao.ReservationDao;
import gz.cyberbrain.cyberhotel.model.reservation.to.ReservationTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RegisteredReservationException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class RemoveAReservationAction {

	private ReservationTo reservationTo;
	private ReservationDao reservationDao;
	private RequestDao requestDao;

	public RemoveAReservationAction(ReservationTo reservationTo, ReservationDao reservationDao, RequestDao requestDao) {		
		this.reservationTo = reservationTo;
		this.requestDao = requestDao;
		this.reservationDao = reservationDao;
	}
	
	public void execute() throws RegisteredReservationException, InternalErrorException {
		
		if (reservationTo.getReservationStatus().equals("Pendente")) 
			throw new RegisteredReservationException(reservationTo);
		
		if (reservationTo.getReservationStatus().equals("Rexistrada")) 
			throw new RegisteredReservationException(reservationTo);
		
		if (reservationTo.getReservationStatus().equals("Finalizada")) 
			throw new RegisteredReservationException(reservationTo);
		
		Collection requests = reservationDao.findRequests(reservationTo.getReservationId());
		
		Iterator iter = requests.iterator();
		//System.out.println("REQUESTS: " + requests.size());
		for (int i=0; iter.hasNext();i++) {
			requestDao.remove((RequestTo) iter.next());
			//System.out.println("Borrada Request: " + i);
		}
		
		reservationDao.remove(reservationTo);
		
	}
	
}
