package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.client.to.AgencyTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.AgencyWithReservationsException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class RemoveAnAgencyAction {

private AgencyTo agencyTo;
private ClientDao agencyDao;
	
	public RemoveAnAgencyAction(AgencyTo agencyTo, ClientDao agencyDao) {
		this.agencyTo = agencyTo;
		this.agencyDao = agencyDao;
	}
	
	public void execute() 
		throws AgencyWithReservationsException, ClientPayerException, 
		ClientWithInvoicesException, InternalErrorException {
		
		if (agencyDao.isPayer(agencyTo.getClientId()))
			throw new ClientPayerException(agencyTo);
		
		if (agencyDao.existInvoices(agencyTo.getClientId()))
			throw new ClientWithInvoicesException(agencyTo);
		
		if (agencyDao.takesPartInReservation(agencyTo.getClientId()))
			throw new AgencyWithReservationsException(agencyTo);
		
		agencyDao.remove(agencyTo);
		
	}

}
