package gz.cyberbrain.cyberhotel.model.roomtype.dao;

import gz.cyberbrain.cyberhotel.model.roomtype.to.RoomTypeTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class RoomTypeSpringDao extends AbstractSpringDao implements RoomTypeDao {
	
	
	public RoomTypeSpringDao() {
		super(RoomTypeTo.class);
	}	

	public RoomTypeTo create(RoomTypeTo roomTypeTo) throws InternalErrorException {		

		return (RoomTypeTo) super.save(roomTypeTo);

	}

	public RoomTypeTo find(String roomTypeCode) throws InstanceNotFoundException, InternalErrorException {

		RoomTypeTo roomTypeTo = (RoomTypeTo) super.find(roomTypeCode);
		return roomTypeTo;

	}

	public void update(RoomTypeTo roomTypeTo) throws InternalErrorException {		

		super.update(roomTypeTo);

	}

	public void remove(RoomTypeTo roomTypeTo) throws InternalErrorException {

			super.delete(roomTypeTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allRoomTypes";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existRooms(String roomTypeCode) throws InternalErrorException {
		String queryName = "roomsOfThisType";
		return (!super.findByAttribute(queryName, roomTypeCode).isEmpty());
	}

}
