package gz.cyberbrain.cyberhotel.model.season.dao;

import gz.cyberbrain.cyberhotel.model.season.to.SeasonTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface SeasonDao {

	public SeasonTo create(SeasonTo seasonTo) throws InternalErrorException;

	public SeasonTo find(Long seasonId) 
	throws InstanceNotFoundException, InternalErrorException;

	public void update (SeasonTo seasonTo) 
	throws InternalErrorException;

	public void remove(SeasonTo seasonTo) 
	throws InternalErrorException;

	public Collection findAll() throws InternalErrorException;

	public boolean existRequests (Long seasonId) 
	throws InternalErrorException;

	public boolean isTariffied (Long seasonId)
	throws InternalErrorException;


}
