package gz.cyberbrain.cyberhotel.model.season.dao;

import gz.cyberbrain.cyberhotel.model.season.to.SeasonTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class SeasonSpringDao extends AbstractSpringDao implements SeasonDao {
	
	public SeasonSpringDao() {
		super(SeasonTo.class);
	}	

	public SeasonTo create(SeasonTo seasonTo) throws InternalErrorException {		

		return (SeasonTo) super.save(seasonTo);

	}

	public SeasonTo find(Long seasonId) throws InstanceNotFoundException, InternalErrorException {

		SeasonTo seasonTo = (SeasonTo) super.find(seasonId);
		return seasonTo;

	}

	public void update(SeasonTo seasonTo) throws InternalErrorException {		

		super.update(seasonTo);

	}

	public void remove(SeasonTo seasonTo) throws InternalErrorException {

			super.delete(seasonTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allSeasons";
		return super.findByQuery(queryName);
		
	}

	public boolean existRequests(Long seasonId) throws InternalErrorException {
		String queryName = "seasonRequests";
		return (!super.findByAttribute(queryName, seasonId).isEmpty());
	}
	
	public boolean isTariffied(Long seasonId) throws InternalErrorException {
		String queryName = "seasonPrices";
		return (!super.findByAttribute(queryName, seasonId).isEmpty());
	}

	
}
