package gz.cyberbrain.cyberhotel.model.user.to;
import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.role.to.RoleTo;
import gz.cyberbrain.cyberhotel.model.util.encrypt.PasswordEncrypter;

import java.io.Serializable;
import java.util.Collection;


public class UserTo implements Identifiable {
		
	private static final long serialVersionUID = 7904835907732056652L;
	private String login;
	private String password;
	private Long  employee;
	private Collection <RoleTo> roles;
	
	public UserTo(){}
	
	public UserTo(String login, String password, Long employee, Collection <RoleTo> roles) {
		this.login = login;
		this.password = PasswordEncrypter.encrypt(password,login);
		this.employee = employee;
		this.roles = roles;
	}

	public Serializable getId(){
		return login;
	}

	public Long getEmployee() {
		return employee;
	}



	public void setEmployee(Long employee) {
		this.employee = employee;
	}



	public String getLogin() {
		return login;
	}



	public void setLogin(String login) {
		this.login = login;
	}



	public String getPassword() {
		return password;
	}



	public void setPassword(String password) {
		this.password = password;
	}



	public Collection <RoleTo> getRoles() {
		return roles;
	}



	public void setRoles(Collection <RoleTo> roles) {
		this.roles = roles;
	}
			
}
