package gz.cyberbrain.cyberhotel.model.util.dates;

import gz.cyberbrain.cyberhotel.model.util.exceptions.InvalidIntervalException;

import java.util.Calendar;

public class Interval {

	private Calendar start;
	private Calendar end;
	
	public Interval (Calendar start, Calendar end) throws InvalidIntervalException {
		if (start.getTime().getTime() > end.getTime().getTime()) throw new InvalidIntervalException(start, end);
		this.start = start;
		this.end = end;		
	}
	
	public Calendar getStart() {
		return start;
	}
	
	public Calendar getEnd() {
		return end;
	}
	
	public boolean overlaps(Interval b) {
		
		if (((b.getEnd().getTime().getTime() >= this.getStart().getTime().getTime()) && (b.getEnd().getTime().getTime() <= this.getEnd().getTime().getTime())) 
		|| ((b.getStart().getTime().getTime() >= this.getStart().getTime().getTime())&&(b.getStart().getTime().getTime() <= this.getEnd().getTime().getTime()))
		|| ((b.getStart().getTime().getTime() >= this.getStart().getTime().getTime())&& (b.getEnd().getTime().getTime() <= this.getEnd().getTime().getTime()))
		|| ((b.getStart().getTime().getTime() <= this.getStart().getTime().getTime()) && (b.getEnd().getTime().getTime() >= this.getEnd().getTime().getTime()))
		)  return true;
				
		return false;
		
	}
	
	public String toString() {
		return new String ("|" + start.get(Calendar.DATE)+"/"+start.get(Calendar.MONTH)+"/"+start.get(Calendar.YEAR) + " - " + end.get(Calendar.DATE)+"/"+end.get(Calendar.MONTH)+"/"+end.get(Calendar.YEAR) + "|");
	}
	
}
