package gz.cyberbrain.cyberhotel.model.util.exceptions;

import gz.cyberbrain.cyberhotel.model.util.dates.Interval;

public class OverlappingException extends ModelException {

	private static final long serialVersionUID = 2459326810549518669L;
	private Interval firstInterval;
	private Interval secondInterval;
	
    public OverlappingException(Interval firstInterval, Interval secondInterval) {
    	super("Overlapped Intervals Found: " + firstInterval + " <-> " + secondInterval);
    	this.firstInterval = firstInterval;
    	this.secondInterval = secondInterval;
    }
    
    public Interval getFirstInterval() {
    	return firstInterval;
    }
    
    public Interval getSecondInterval() {
    	return secondInterval;
    }
	
}
