package gz.cyberbrain.cyberhotel.model.util.money;

import java.math.BigDecimal;

public final class MoneyOperations {
	
	private final static int NUMBER_OF_DECIMALS = 2;
	
	private MoneyOperations(){}

	public final static BigDecimal getDecimalReduction(BigDecimal money){
		
		return money.setScale(NUMBER_OF_DECIMALS, BigDecimal.ROUND_HALF_UP);
		
	}
	
	public final static BigDecimal getPriceWithVat(BigDecimal value, BigDecimal vat) {
		
		BigDecimal valueVat = (value.multiply(vat)).divide(new BigDecimal(100));
		
		return value.add(valueVat);
		
	}
	
}
