package gz.cyberbrain.cyberhotel.security;

import java.util.ArrayList;
import java.util.Collection;

import org.acegisecurity.Authentication;
import org.acegisecurity.GrantedAuthority;
import org.acegisecurity.context.SecurityContextHolder;
import org.acegisecurity.context.SecurityContextImpl;
import org.acegisecurity.providers.AuthenticationProvider;
import org.acegisecurity.providers.UsernamePasswordAuthenticationToken;
import org.acegisecurity.userdetails.User;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class SecurityHandler {

	private static ApplicationContext context;

	static {
		context = new ClassPathXmlApplicationContext("applicationContext.xml");
	}

	private SecurityHandler(){}	

	public static void setSecureContext(final String username, final String password) {
		
		AuthenticationProvider provider = 
			(AuthenticationProvider) context.getBean("daoAuthenticationProvider");
		
		Authentication auth = 
			provider.authenticate(new UsernamePasswordAuthenticationToken(username, password));
		
		SecurityContextHolder.getContext().setAuthentication(auth);
				
	}

	private static Authentication getCurrentAuthentication(){
		if (SecurityContextHolder.getContext().getAuthentication() == null) System.out.println("MERDA!!!");
		return SecurityContextHolder.getContext().getAuthentication();
		
	}

	public static Collection getAuthenticationCredentials(){

		Authentication auth = getCurrentAuthentication();

		if (auth != null) {

			GrantedAuthority []auths = auth.getAuthorities();

			Collection<String>roles = new ArrayList<String>();				

			for (int i=0; i<auths.length; i++) 
				roles.add(auths[i].getAuthority());			

			return roles;

		} else 

			return null;

	}

	public static String getAuthenticatedLogin(){
		Authentication auth = getCurrentAuthentication();

		if (auth != null)
			return (String) ((User)auth.getPrincipal()).getUsername();
		else 
			return null;
	}

	public static void clearSecurityContext(){
		SecurityContextHolder.setContext(new SecurityContextImpl());
	}
		
}
