package gz.cyberbrain.cyberhotel.view.swing.edit;

import gz.cyberbrain.cyberhotel.controller.SaveAdapter;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.view.swing.FillableWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.LimitDocument;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel; 
import javax.swing.JLabel;
import javax.swing.UIManager;

import java.awt.Color;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.HashMap;

import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.border.LineBorder;

public class ConceptWindow extends FillableWindow {

	private static final long serialVersionUID = 1L;

	private static ConceptWindow conceptWindow = null;

	private SaveAdapter saveAdapter = null;

	private Serializable id = null;

	private JInternalFrame owner = null;

	private String dialogMessage = null;

	private String dialogTitle = null;

	private JPanel jContentPane = null;

	private JLabel codeLabel = null;

	private JTextField codeTextField = null;

	private JLabel descLabel = null;

	private JTextField descTextField = null;

	private JLabel vatLabel = null;

	private JTextField vatTextField = null;

	private JLabel percentLabel = null;

	private JButton saveButton = null;

	private JButton cancelButton = null;

	private InfoPanel infoPanel = null;

	/**
	 * @param owner
	 */
	private ConceptWindow() {
		super("", false, true, false, true);
		initialize();
	}

	public static ConceptWindow getInstance() {
		if (conceptWindow == null) conceptWindow = new ConceptWindow();
		return conceptWindow;
	}

	public void setAdapter(SaveAdapter saveAdapter) {
		this.saveAdapter = saveAdapter;
	}

	public SaveAdapter getAdapter() {
		return saveAdapter;
	}

	public String getDialogMessage() {
		return dialogMessage;
	}

	public void setDialogMessage(String dialogMessage) {
		this.dialogMessage = dialogMessage;
	}

	public String getDialogTitle() {
		return dialogTitle;
	}

	public void setDialogTitle(String dialogTitle) {
		this.dialogTitle = dialogTitle;
	}


	public void setId(Serializable id) {
		this.id = id;
	}

	public Serializable getId() {
		return id;
	}

	public JInternalFrame getOwner() {
		return owner;
	}

	public void setOwner(JInternalFrame owner) {
		this.owner = owner;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(719, 173);
		this.setLocation(387,0);
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter()
		{
			public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt)
			{
				(ConceptWindow.getInstance()).clean();
				(ConceptWindow.getInstance()).dispose();

			}
		});	

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			percentLabel = new JLabel();
			percentLabel.setBounds(new Rectangle(687, 72, 16, 19));
			percentLabel.setText("%");
			vatLabel = new JLabel();
			vatLabel.setBounds(new Rectangle(602, 72, 27, 16));
			vatLabel.setText(Locale.get("ConceptWindow.vatLabel"));
			descLabel = new JLabel();
			descLabel.setBounds(new Rectangle(137, 72, 62, 17));
			descLabel.setText(Locale.get("ConceptWindow.descLabel"));
			codeLabel = new JLabel();
			codeLabel.setBounds(new Rectangle(19, 72, 48, 16));
			codeLabel.setText(Locale.get("ConceptWindow.codeLabel"));
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(codeLabel, null);
			jContentPane.add(getCodeTextField(), null);
			jContentPane.add(descLabel, null);
			jContentPane.add(getDescTextField(), null);
			jContentPane.add(vatLabel, null);
			jContentPane.add(getVatTextField(), null);
			jContentPane.add(percentLabel, null);
			jContentPane.add(getSaveButton(), null);
			jContentPane.add(getCancelButton(), null);
			jContentPane.add(getInfoPanel(),null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes codeTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getCodeTextField() {
		if (codeTextField == null) {
			codeTextField = new JTextField();
			codeTextField.setBounds(new Rectangle(77, 72, 48, 17));
		}
		return codeTextField;
	}

	/**
	 * This method initializes descTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDescTextField() {
		if (descTextField == null) {
			descTextField = new JTextField();
			descTextField.setBounds(new Rectangle(202, 72, 395, 19));
		}
		return descTextField;
	}

	/**
	 * This method initializes vatTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getVatTextField() {
		if (vatTextField == null) {
			vatTextField = new JTextField();
			vatTextField.setBounds(new Rectangle(633, 72, 50, 20));
			vatTextField.setDocument(new LimitDocument(6));
			vatTextField.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(KeyEvent e) {

					if (e.getKeyChar() == KeyEvent.VK_COMMA) e.setKeyChar('.');			    	  			        
					if (!Character.isDigit(e.getKeyChar()) && e.getKeyChar() != KeyEvent.VK_PERIOD) e.consume();
					if ((e.getKeyChar() == KeyEvent.VK_PERIOD) && vatTextField.getText().contains(".")) e.consume();

				}
			});

		}
		return vatTextField;
	}

	/**
	 * This method initializes saveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSaveButton() {
		if (saveButton == null) {
			saveButton = new JButton();
			saveButton.setText(Locale.get("ConceptWindow.saveButton"));
			saveButton.setBounds(new Rectangle(524, 105, 83, 18));
			saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					HashMap<String, Object> attrs = new HashMap<String, Object>();
					attrs.put("code", getCodeTextField().getText());
					attrs.put("denomination", getDescTextField().getText());
					
					try {
					
						attrs.put("vat", new BigDecimal(getVatTextField().getText()));
					
					} catch (NumberFormatException e1) {
						attrs.put("vat", new BigDecimal("0"));
					}

					setDialogMessage(Locale.get("JOptionPane.ConceptWindow.saveButton.message"));
					setDialogTitle(Locale.get("JOptionPane.ConceptWindow.saveButton.title"));

					getAdapter().save(attrs);

					if (!inputErrors()) {

						Object[] options = {Locale.get("JOptionPane.Ok")};
						int n = JOptionPane.showOptionDialog(RoomTypeWindow.getInstance(),
								getDialogMessage(),
								getDialogTitle(),
								JOptionPane.OK_OPTION,
								JOptionPane.INFORMATION_MESSAGE,
								null,
								options,
								options[0]);

						if (n == JOptionPane.OK_OPTION) {
							ListWindow listWindow = (ListWindow) getOwner();
							listWindow.loadList();
							clean();
							dispose();	                    	
						}

					}

				}

			});

		}
		return saveButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Locale.get("ConceptWindow.cancelButton"));
			cancelButton.setBounds(new Rectangle(617, 105, 83, 18));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					(ConceptWindow.getInstance()).clean();
					(ConceptWindow.getInstance()).dispose();

				}
			});
		}
		return cancelButton;
	}

	/**
	 * This method initializes infoPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private InfoPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(0,0,this.getWidth(),50);
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {		  

		jContentPane.remove(infoPanel);
		infoPanel = ipanel;
		jContentPane.add(infoPanel);

	}

	public void clean() {
		getInfoPanel().setInfoText(getInfoPanel().getInfoText());
		getCodeTextField().setEditable(true);
		getCodeTextField().setText("");
		getDescTextField().setText("");
		getVatTextField().setText("");
		getCodeTextField().setBorder(UIManager.getBorder("TextField.border"));
		getDescTextField().setBorder(UIManager.getBorder("TextField.border"));
	}

	public void fill(HashMap fields) {

		getCodeTextField().setEditable(false);
		getCodeTextField().setText((String) fields.get("code"));
		getDescTextField().setText((String) fields.get("denomination"));
		getVatTextField().setText(fields.get("vat").toString());

	}

	private boolean inputErrors() {

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("code")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ConceptWindow.errors.code")+ "</html>");			
				getCodeTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("denomination")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ConceptWindow.errors.denomination")+ "</html>");			
				getDescTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

		}

		return false;

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
