package gz.cyberbrain.cyberhotel.view.swing.reception;

import gz.cyberbrain.cyberhotel.controller.AddressController;
import gz.cyberbrain.cyberhotel.controller.BankListAdapter;
import gz.cyberbrain.cyberhotel.controller.CardListAdapter;
import gz.cyberbrain.cyberhotel.controller.CompanyListAdapter;
import gz.cyberbrain.cyberhotel.controller.SaveAdapter;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;
import gz.cyberbrain.cyberhotel.view.swing.FillableWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.ListWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.RoomTypeWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.AlphanumericDocument;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.DateFormat;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.ImageItem;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.IntegerDocument;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import java.awt.Color;
import java.awt.Rectangle; 
import java.awt.Dimension; 
import java.awt.Toolkit;
import java.io.Serializable;
import java.text.ParseException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFormattedTextField;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.UIManager;
import javax.swing.border.LineBorder;
import javax.swing.text.Document;

public class ParticularWindow extends FillableWindow {

	private static final long serialVersionUID = 1L;

	private static ParticularWindow particularWindow = null;

	private Serializable id = null;

	private SaveAdapter saveAdapter = null;  //  @jve:decl-index=0:

	private JInternalFrame owner = null;	

	private String dialogTitle = null;

	private String dialogMessage = null;

	private JPanel jContentPane = null;

	private InfoPanel infoPanel = null;

	private JPanel firstPanel = null;  //  @jve:decl-index=0:visual-constraint="769,101"

	private JLabel nameLabel = null;

	private JLabel firstSurmaneLabel = null;

	private JLabel secondSurnameLabel = null;

	private JTextField nameTextField = null;

	private JTextField firstSurnameTextField = null;

	private JTextField secondSurnameTextField = null;

	private JLabel countryLabel = null;

	private JLabel provinceLabel = null;

	private JLabel localityLabel = null;

	private JLabel dwellingPlaceLabel = null;

	private JLabel phone1Label = null;

	private JLabel phone2Label = null;

	private JLabel faxLabel = null;

	private JLabel emailLabel = null;

	private JLabel webLabel = null;

	private JLabel notesLabel = null;

	private JTextField dwellingPlaceTextField = null;

	private JTextField phone1TextField = null;

	private JTextField phone2TextField = null;

	private JTextField faxTextField = null;

	private JTextField emailTextField = null;

	private JTextField webTextField = null;	

	private JTabbedPane jTabbedPane = null;

	private JLabel streetLabel = null;

	private JTextField streetTextField = null;

	private JLabel bornLabel = null;

	private JFormattedTextField bornTextField = null;

	private JComboBox countryComboBox = null;

	private JComboBox provinceComboBox = null;

	private JComboBox localityComboBox = null;

	private JButton saveButton = null;

	private JButton cancelButton = null;

	private JPanel secondPanel = null;  //  @jve:decl-index=0:visual-constraint="1467,103"

	private JLabel documentTypeLabel = null;

	private JComboBox documentTypeComboBox = null;

	private JLabel documentNumberLabel = null;

	private JTextField documentNumberTextField = null;

	private JLabel expeditionLabel = null;

	private JFormattedTextField expeditionTextField = null;

	private JLabel expirationLabel = null;

	private JFormattedTextField expirationTextField = null;

	private JRadioButton maleRadioButton = null;

	private JRadioButton femaleRadioButton = null;

	private ButtonGroup buttonGroup = null;

	private JLabel nationalityLabel = null;

	private JComboBox nationalityComboBox = null;

	private JPanel thirdPanel = null;  //  @jve:decl-index=0:visual-constraint="2179,104"

	private JLabel payModeLabel = null;

	private JComboBox payModeComboBox = null;

	private JLabel accountNumLabel = null;

	private JTextField accountNumTextField = null;

	private JLabel cardNumLabel = null;

	private JTextField cardNumTextField = null;

	private JLabel voucherNumLabel = null;

	private JTextField voucherNumTextField = null;

	private JLabel bankLabel = null;

	private JComboBox bankComboBox = null;

	private JLabel cardLabel = null;

	private JComboBox cardComboBox = null;

	private JLabel companyLabel = null;

	private JComboBox companyComboBox = null;

	private JLabel jobLabel = null;

	private JTextField jobTextField = null;

	private JLabel clientTypeLabel = null;

	private JComboBox clientTypeComboBox = null;

	private JScrollPane jScrollPane = null;

	private JTextArea jTextArea = null;

	/**
	 * @param owner
	 */
	private ParticularWindow() {
		super("", false, true, false, true);
		initialize();
	}

	public static ParticularWindow getInstance() {
		if (particularWindow == null) particularWindow = new ParticularWindow();
		return particularWindow;
	}

	public void setAdapter(SaveAdapter saveAdapter) {
		this.saveAdapter = saveAdapter;
	}

	public SaveAdapter getAdapter() {
		return saveAdapter;
	}

	public JInternalFrame getOwner() {
		return owner;
	}

	public void setOwner(JInternalFrame owner) {
		this.owner = owner;
	}

	public String getDialogMessage() {
		return dialogMessage;
	}

	public void setDialogMessage(String dialogMessage) {
		this.dialogMessage = dialogMessage;
	}

	public String getDialogTitle() {
		return dialogTitle;
	}

	public void setDialogTitle(String dialogTitle) {
		this.dialogTitle = dialogTitle;
	}

	public void setId(Serializable id) {
		this.id = id;
	}

	public Serializable getId() {
		return id;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(704, 501);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter()
		{
			private int selectedTab = 0;
			private int selectedPayMode = 0;
			private int selectedBank = 0;
			private int selectedCard = 0;
			private int selectedCountry = 0;
			private int selectedProvince = 0;
			private int selectedLocality = 0;
			private int selectedNationality = 0;
			private int selectedDocumentType = 0;
			//private int selectedCompany = 0;
			private int selectedClientType = 0;

			public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt)
			{
				(ParticularWindow.getInstance()).clean();
			}

			public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {

				jContentPane = null;
				jTabbedPane = null;
				firstPanel = null;
				secondPanel = null;
				thirdPanel = null;
				bankComboBox = null;
				cardComboBox = null;
				countryComboBox = null;
				provinceComboBox = null;
				localityComboBox = null;
				nationalityComboBox = null;
				documentTypeComboBox = null;
				companyComboBox = null;
				clientTypeComboBox = null;

				(ParticularWindow.getInstance()).setContentPane(getJContentPane());
				getJTabbedPane().setSelectedIndex(selectedTab);
				if (getPayModeComboBox().getItemCount() != 0) getPayModeComboBox().setSelectedIndex(selectedPayMode);
				if(getBankComboBox().getItemCount() != 0) getBankComboBox().setSelectedIndex(selectedBank);
				if(getCardComboBox().getItemCount() != 0) getCardComboBox().setSelectedIndex(selectedCard);
				if (getCountryComboBox().getItemCount() != 0) getCountryComboBox().setSelectedIndex(selectedCountry);
				if (getProvinceComboBox().getItemCount() != 0) getProvinceComboBox().setSelectedIndex(selectedProvince);
				if (getLocalityComboBox().getItemCount() != 0) getLocalityComboBox().setSelectedIndex(selectedLocality);
				if (getNationalityComboBox().getItemCount() != 0) getNationalityComboBox().setSelectedIndex(selectedNationality);
				if (getDocumentTypeComboBox().getItemCount() != 0) getDocumentTypeComboBox().setSelectedIndex(selectedDocumentType);
//				getCompanyComboBox().setSelectedIndex(selectedCompany);
				if (getClientTypeComboBox().getItemCount() != 0) getClientTypeComboBox().setSelectedIndex(selectedClientType);

			}

			public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {

				selectedTab = getJTabbedPane().getSelectedIndex();
				selectedPayMode = getPayModeComboBox().getSelectedIndex();
				selectedBank = getBankComboBox().getSelectedIndex();
				selectedCard = getCardComboBox().getSelectedIndex();
				selectedCountry = getCountryComboBox().getSelectedIndex();
				selectedProvince = getProvinceComboBox().getSelectedIndex();
				selectedLocality = getLocalityComboBox().getSelectedIndex();
				selectedNationality = getNationalityComboBox().getSelectedIndex();
				selectedDocumentType = getDocumentTypeComboBox().getSelectedIndex();
				//selectedCompany = getCompanyComboBox().getSelectedIndex();
				selectedClientType = getClientTypeComboBox().getSelectedIndex();

			}

		});


	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getInfoPanel(), null);
			jContentPane.add(getJTabbedPane(), null);
			jContentPane.add(getSaveButton(), null);
			jContentPane.add(getCancelButton(), null);
		}
		return jContentPane;
	}

	private InfoPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(0,0,this.getWidth(),50);
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {		  

		jContentPane.remove(infoPanel);
		infoPanel = ipanel;
		jContentPane.add(infoPanel);

	}

	/**
	 * This method initializes firstPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getFirstPanel() {
		if (firstPanel == null) {
			clientTypeLabel = new JLabel();
			clientTypeLabel.setBounds(new Rectangle(525, 16, 74, 16));
			clientTypeLabel.setText(Locale.get("ParticularWindow.clientTypeLabel"));
			jobLabel = new JLabel();
			jobLabel.setBounds(new Rectangle(385, 187, 86, 16));
			jobLabel.setText(Locale.get("ParticularWindow.jobLabel"));
			companyLabel = new JLabel();
			companyLabel.setBounds(new Rectangle(12, 187, 63, 16));
			companyLabel.setText(Locale.get("ParticularWindow.companyLabel"));
			bornLabel = new JLabel();
			bornLabel.setBounds(new Rectangle(349, 14, 91, 16));
			bornLabel.setText(Locale.get("ParticularWindow.bornLabel"));
			streetLabel = new JLabel();
			streetLabel.setBounds(new Rectangle(12, 158, 63, 16));
			streetLabel.setText(Locale.get("ParticularWindow.streetLabel"));
			notesLabel = new JLabel();
			notesLabel.setBounds(new Rectangle(11, 273, 38, 16));
			notesLabel.setText(Locale.get("ParticularWindow.notesLabel"));
			webLabel = new JLabel();
			webLabel.setBounds(new Rectangle(299, 243, 31, 16));
			webLabel.setText(Locale.get("ParticularWindow.webLabel"));
			emailLabel = new JLabel();
			emailLabel.setBounds(new Rectangle(11, 242, 38, 16));
			emailLabel.setText(Locale.get("ParticularWindow.emailLabel"));
			faxLabel = new JLabel();
			faxLabel.setBounds(new Rectangle(391, 214, 25, 16));
			faxLabel.setText(Locale.get("ParticularWindow.faxLabel"));
			phone2Label = new JLabel();
			phone2Label.setBounds(new Rectangle(223, 214, 25, 16));
			phone2Label.setText(Locale.get("ParticularWindow.phone2Label"));
			phone1Label = new JLabel();
			phone1Label.setBounds(new Rectangle(11, 214, 30, 16));
			phone1Label.setText(Locale.get("ParticularWindow.phone1Label"));
			dwellingPlaceLabel = new JLabel();
			dwellingPlaceLabel.setBounds(new Rectangle(385, 158, 86, 16));
			dwellingPlaceLabel.setText(Locale.get("ParticularWindow.dwellingPlaceLabel"));
			localityLabel = new JLabel();
			localityLabel.setBounds(new Rectangle(12, 127, 63, 16));
			localityLabel.setText(Locale.get("ParticularWindow.localityLabel"));
			provinceLabel = new JLabel();
			provinceLabel.setBounds(new Rectangle(12, 98, 63, 16));
			provinceLabel.setText(Locale.get("ParticularWindow.provinceLabel"));
			countryLabel = new JLabel();
			countryLabel.setBounds(new Rectangle(12, 72, 63, 16));
			countryLabel.setText(Locale.get("ParticularWindow.countryLabel"));
			secondSurnameLabel = new JLabel();
			secondSurnameLabel.setBounds(new Rectangle(349, 39, 91, 16));
			secondSurnameLabel.setText(Locale.get("ParticularWindow.secondSurnameLabel"));
			firstSurmaneLabel = new JLabel();
			firstSurmaneLabel.setBounds(new Rectangle(12, 39, 75, 15));
			firstSurmaneLabel.setText(Locale.get("ParticularWindow.firstSurnameLabel"));
			nameLabel = new JLabel();
			nameLabel.setBounds(new Rectangle(12, 14, 50, 15));
			nameLabel.setText(Locale.get("ParticularWindow.nameLabel"));
			firstPanel = new JPanel();
			firstPanel.setLayout(null);
			firstPanel.setSize(new Dimension(686, 346));
			firstPanel.add(nameLabel, null);
			firstPanel.add(firstSurmaneLabel, null);
			firstPanel.add(secondSurnameLabel, null);
			firstPanel.add(getNameTextField(), null);
			firstPanel.add(getFirstSurnameTextField(), null);
			firstPanel.add(getSecondSurnameTextField(), null);
			firstPanel.add(countryLabel, null);
			firstPanel.add(provinceLabel, null);
			firstPanel.add(localityLabel, null);
			firstPanel.add(dwellingPlaceLabel, null);
			firstPanel.add(phone1Label, null);
			firstPanel.add(phone2Label, null);
			firstPanel.add(faxLabel, null);
			firstPanel.add(emailLabel, null);
			firstPanel.add(webLabel, null);
			firstPanel.add(notesLabel, null);
			firstPanel.add(getDwellingPlaceTextField(), null);
			firstPanel.add(getPhone1TextField(), null);
			firstPanel.add(getPhone2TextField(), null);
			firstPanel.add(getFaxTextField(), null);
			firstPanel.add(getEmailTextField(), null);
			firstPanel.add(getWebTextField(), null);
			firstPanel.add(streetLabel, null);
			firstPanel.add(getStreetTextField(), null);
			firstPanel.add(bornLabel, null);
			firstPanel.add(getBornTextField(), null);
			firstPanel.add(getCountryComboBox(), null);
			firstPanel.add(getProvinceComboBox(), null);
			firstPanel.add(getLocalityComboBox(), null);
			firstPanel.add(companyLabel, null);
			firstPanel.add(getCompanyComboBox(), null);
			firstPanel.add(jobLabel, null);
			firstPanel.add(getJobTextField(), null);
			firstPanel.add(clientTypeLabel, null);
			firstPanel.add(getClientTypeComboBox(), null);
			firstPanel.add(getJScrollPane(), null);
		}
		return firstPanel;
	}

	/**
	 * This method initializes nameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNameTextField() {
		if (nameTextField == null) {
			nameTextField = new JTextField();
			nameTextField.setBounds(new Rectangle(94, 14, 230, 18));
		}
		return nameTextField;
	}

	/**
	 * This method initializes firstSurnameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getFirstSurnameTextField() {
		if (firstSurnameTextField == null) {
			firstSurnameTextField = new JTextField();
			firstSurnameTextField.setBounds(new Rectangle(94, 37, 230, 18));
		}
		return firstSurnameTextField;
	}

	/**
	 * This method initializes secondSurnameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSecondSurnameTextField() {
		if (secondSurnameTextField == null) {
			secondSurnameTextField = new JTextField();
			secondSurnameTextField.setBounds(new Rectangle(444, 39, 230, 18));
		}
		return secondSurnameTextField;
	}

	/**
	 * This method initializes dwellingPlaceTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDwellingPlaceTextField() {
		if (dwellingPlaceTextField == null) {
			dwellingPlaceTextField = new JTextField();
			dwellingPlaceTextField.setBounds(new Rectangle(476, 157, 198, 18));
		}
		return dwellingPlaceTextField;
	}

	/**
	 * This method initializes phone1TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPhone1TextField() {
		if (phone1TextField == null) {
			Document integerDocument = new IntegerDocument(15);
			phone1TextField = new JTextField(integerDocument,"",15);			
			phone1TextField.setHorizontalAlignment(JTextField.TRAILING);			
			phone1TextField.setBounds(new Rectangle(93, 214, 124, 18));			
		}
		return phone1TextField;
	}

	/**
	 * This method initializes phone2TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPhone2TextField() {
		if (phone2TextField == null) {
			Document integerDocument = new IntegerDocument(15);
			phone2TextField = new JTextField(integerDocument,"",15);
			phone2TextField.setHorizontalAlignment(JTextField.TRAILING);
			phone2TextField.setBounds(new Rectangle(251, 214, 130, 18));
		}
		return phone2TextField;
	}

	/**
	 * This method initializes faxTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getFaxTextField() {
		if (faxTextField == null) {
			Document integerDocument = new IntegerDocument(15);
			faxTextField = new JTextField(integerDocument,"",15);
			faxTextField.setHorizontalAlignment(JTextField.TRAILING);
			faxTextField.setBounds(new Rectangle(419, 214, 130, 18));
		}
		return faxTextField;
	}

	/**
	 * This method initializes emailTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getEmailTextField() {
		if (emailTextField == null) {
			emailTextField = new JTextField();
			emailTextField.setBounds(new Rectangle(93, 242, 194, 18));
		}
		return emailTextField;
	}

	/**
	 * This method initializes webTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getWebTextField() {
		if (webTextField == null) {
			webTextField = new JTextField();
			webTextField.setBounds(new Rectangle(335, 242, 338, 18));
		}
		return webTextField;
	}

	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setBounds(new Rectangle(7, 59, 683, 366));
			jTabbedPane.add(Locale.get("ParticularWindow.firstTab"),getFirstPanel());
			jTabbedPane.add(Locale.get("ParticularWindow.secondTab"),getSecondPanel());
			jTabbedPane.add(Locale.get("ParticularWindow.thirdTab"), getThirdPanel());
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes streetTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getStreetTextField() {
		if (streetTextField == null) {
			streetTextField = new JTextField();
			streetTextField.setBounds(new Rectangle(94, 157, 282, 18));
		}
		return streetTextField;
	}

	/**
	 * This method initializes streetTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JFormattedTextField getBornTextField() {

		try {

			if (bornTextField == null) {
				bornTextField = new JFormattedTextField(new DateFormat());
				bornTextField.setBounds(new Rectangle(444, 14, 74, 18));
			}

		} catch (ParseException e) {}

		return bornTextField;
	}

	/**
	 * This method initializes countryComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCountryComboBox() {
		if (countryComboBox == null) {

			countryComboBox = new JComboBox(AddressController.countriesList().toArray());

			countryComboBox.setBounds(new Rectangle(94, 72, 213, 18));
			countryComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {


					ComboBoxModel model = new DefaultComboBoxModel(AddressController.countryProvincesList((String)getCountryComboBox().getSelectedItem()).toArray());
					getProvinceComboBox().setModel(model);
					if (getProvinceComboBox().getItemCount() != 0) getProvinceComboBox().setSelectedIndex(0); 


				}
			});

		}
		return countryComboBox;
	}

	/**
	 * This method initializes provinceComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getProvinceComboBox() {
		if (provinceComboBox == null) {

			provinceComboBox = new JComboBox(AddressController.countryProvincesList((String) getCountryComboBox().getSelectedItem()).toArray());

			provinceComboBox.setBounds(new Rectangle(94, 98, 213, 18));
			provinceComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					ComboBoxModel model = new DefaultComboBoxModel(AddressController.provinceLocalitiesList((String)getCountryComboBox().getSelectedItem(), (String)getProvinceComboBox().getSelectedItem()).toArray());
					getLocalityComboBox().setModel(model);						
					if (getLocalityComboBox().getItemCount() != 0) getLocalityComboBox().setSelectedIndex(0);

				}
			});

		}
		return provinceComboBox;
	}

	/**
	 * This method initializes localityComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getLocalityComboBox() {
		if (localityComboBox == null) {
			localityComboBox = new JComboBox(AddressController.provinceLocalitiesList((String)getCountryComboBox().getSelectedItem(), (String)getProvinceComboBox().getSelectedItem()).toArray());
			localityComboBox.setBounds(new Rectangle(94, 127, 213, 18));
		}
		return localityComboBox;
	}

	/**
	 * This method initializes saveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSaveButton() {
		if (saveButton == null) {
			saveButton = new JButton();
			saveButton.setText(Locale.get("ParticularWindow.saveButton"));
			saveButton.setBounds(new Rectangle(500, 438, 82, 20));
			saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					HashMap<String, Object> attrs = new HashMap<String, Object>();
					attrs.put("id", (Long) getId());

					attrs.put("address", 
							AddressController.findAddressId(
									(String) getCountryComboBox().getSelectedItem(), 
									(String) getProvinceComboBox().getSelectedItem(),
									(String) getLocalityComboBox().getSelectedItem()
							)
					);

					attrs.put("street", getStreetTextField().getText());
					attrs.put("dwellingPlace", getDwellingPlaceTextField().getText()); 
					attrs.put("phone1", getPhone1TextField().getText());
					attrs.put("phone2", getPhone2TextField().getText());
					attrs.put("fax", getFaxTextField().getText());
					attrs.put("email", getEmailTextField().getText()); 
					attrs.put("web", getWebTextField().getText());

					if (getBankComboBox().getItemCount() != 0) attrs.put("bank", (Long) ((ImageItem) getBankComboBox().getSelectedItem()).getId());
					else attrs.put("bank", null);

					if (getCardComboBox().getItemCount() != 0) attrs.put("card", (Long) ((ImageItem) getCardComboBox().getSelectedItem()).getId());
					else attrs.put("card", null);

					attrs.put("notes", getJTextArea().getText()); 
					attrs.put("name", getNameTextField().getText());
					attrs.put("firstSurname", getFirstSurnameTextField().getText());
					attrs.put("secondSurname", getSecondSurnameTextField().getText());																				
					attrs.put("bornDate", DateOperations.textToCalendar(getBornTextField().getText()));										

					String documentType = "DNI";
					switch (getDocumentTypeComboBox().getSelectedIndex()) {
					case 0:
						documentType = "DNI";
						break;
					case 1:
						documentType = "Pasaporte";
						break;
					}
					attrs.put("documentType", documentType);
					attrs.put("documentNumber", getDocumentNumberTextField().getText());
					attrs.put("expeditionDate", DateOperations.textToCalendar(getExpeditionTextField().getText()));
					attrs.put("expirationDate", DateOperations.textToCalendar(getExpirationTextField().getText()));

					String sex;
					if (getMaleRadioButton().isSelected()) sex = "H"; else sex = "M";
					attrs.put("sex", sex);

					attrs.put("nationality", (String) getNationalityComboBox().getSelectedItem());
					attrs.put("job", getJobTextField().getText());

					if (getCompanyComboBox().getItemCount() != 0 && ((Long) ((TextItem) getCompanyComboBox().getSelectedItem()).getId() != 0)) attrs.put("company", ((TextItem) getCompanyComboBox().getSelectedItem()).getId());
					else attrs.put("company", null);	
					

					String payMode = "Contado";
					switch(getPayModeComboBox().getSelectedIndex()) {
					case 0:
						payMode = "Contado";
						break;
					case 1:
						payMode = "Tarxeta";
						break;
					case 2:
						payMode = "Bono";
						break;
					}
					attrs.put("payMode", payMode);

					attrs.put("accountNumber", getAccountNumTextField().getText());
					attrs.put("cardNumber", getCardNumTextField().getText());
					attrs.put("voucherCode", getVoucherNumTextField().getText());

					String clientType = "Normal";
					switch(getClientTypeComboBox().getSelectedIndex()) {
					case 0:
						clientType = "Normal";
						break;
					case 1:
						clientType = "VIP";
						break;
					}
					attrs.put("clientType", clientType);

					getAdapter().save(attrs);

					if (!inputErrors()) {

						setDialogMessage(Locale.get("JOptionPane.ParticularWindow.saveButton.message"));
						setDialogTitle(Locale.get("JOptionPane.ParticularWindow.saveButton.title"));

						Object[] options = {Locale.get("JOptionPane.Ok")};
						int n = JOptionPane.showOptionDialog(RoomTypeWindow.getInstance(),
								getDialogMessage(),
								getDialogTitle(),
								JOptionPane.OK_OPTION,
								JOptionPane.INFORMATION_MESSAGE,
								null,
								options,
								options[0]);

						if (n == JOptionPane.OK_OPTION) {
							ListWindow listWindow = (ListWindow) getOwner();						
							listWindow.loadList();
							clean();
							dispose();	                    	
						}											

						ListWindow listWindow = (ListWindow) getOwner();
						listWindow.loadList();

					}

				}

			});

		}
		return saveButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Locale.get("ParticularWindow.cancelButton"));
			cancelButton.setBounds(new Rectangle(597, 438, 82, 20));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					(ParticularWindow.getInstance()).clean();
					(ParticularWindow.getInstance()).dispose();

				}
			});

		}
		return cancelButton;
	}

	/**
	 * This method initializes secondPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSecondPanel() {
		if (secondPanel == null) {			 
			buttonGroup = new ButtonGroup();
			buttonGroup.add(getMaleRadioButton());
			buttonGroup.add(getFemaleRadioButton());
			nationalityLabel = new JLabel();
			nationalityLabel.setBounds(new Rectangle(17, 81, 79, 15));
			nationalityLabel.setText(Locale.get("ParticularWindow.nationalityLabel"));
			expirationLabel = new JLabel();
			expirationLabel.setBounds(new Rectangle(212, 48, 93, 15));
			expirationLabel.setText(Locale.get("ParticularWindow.expirationLabel"));
			expeditionLabel = new JLabel();
			expeditionLabel.setBounds(new Rectangle(18, 48, 93, 15));
			expeditionLabel.setText(Locale.get("ParticularWindow.expeditionLabel"));
			documentNumberLabel = new JLabel();
			documentNumberLabel.setBounds(new Rectangle(211, 17, 89, 15));
			documentNumberLabel.setText(Locale.get("ParticularWindow.documentNumberLabel"));
			documentTypeLabel = new JLabel();
			documentTypeLabel.setBounds(new Rectangle(17, 17, 93, 15));
			documentTypeLabel.setText(Locale.get("ParticularWindow.documentTypeLabel"));
			secondPanel = new JPanel();
			secondPanel.setLayout(null);
			secondPanel.setSize(new Dimension(686, 346));
			secondPanel.add(documentTypeLabel, null);
			secondPanel.add(getDocumentTypeComboBox(), null);
			secondPanel.add(documentNumberLabel, null);
			secondPanel.add(getDocumentNumberTextField(), null);
			secondPanel.add(expeditionLabel, null);
			secondPanel.add(getExpeditionTextField(), null);
			secondPanel.add(expirationLabel, null);
			secondPanel.add(getExpirationTextField(), null);
			secondPanel.add(getMaleRadioButton(), null);
			secondPanel.add(getFemaleRadioButton(), null);
			secondPanel.add(nationalityLabel, null);
			secondPanel.add(getNationalityComboBox(), null);
		}
		return secondPanel;
	}

	/**
	 * This method initializes documentTypeComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getDocumentTypeComboBox() {
		if (documentTypeComboBox == null) {
			documentTypeComboBox = new JComboBox();
			documentTypeComboBox.setBounds(new Rectangle(115, 17, 90, 18));
			documentTypeComboBox.addItem(Locale.get("ParticularWindow.documentTypeComboBox.item0"));
			documentTypeComboBox.addItem(Locale.get("ParticularWindow.documentTypeComboBox.item1"));			
		}
		return documentTypeComboBox;
	}

	/**
	 * This method initializes documentNumberTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDocumentNumberTextField() {
		if (documentNumberTextField == null) {
			Document alphaDocument = new AlphanumericDocument(9);
			documentNumberTextField = new JTextField(alphaDocument,"",9);
			documentNumberTextField.setBounds(new Rectangle(309, 17, 138, 18));
		}
		return documentNumberTextField;
	}

	/**
	 * This method initializes expeditionTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JFormattedTextField getExpeditionTextField() {

		try {

			if (expeditionTextField == null) {
				expeditionTextField = new JFormattedTextField(new DateFormat());
				expeditionTextField.setBounds(new Rectangle(116, 48, 75, 18));
			}

		} catch (ParseException e) {}

		return expeditionTextField;
	}

	/**
	 * This method initializes expirationTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JFormattedTextField getExpirationTextField() {

		try {

			if (expirationTextField == null) {
				expirationTextField = new JFormattedTextField(new DateFormat());
				expirationTextField.setBounds(new Rectangle(310, 46, 75, 18));
			}

		} catch (ParseException e) {}

		return expirationTextField;

	}

	/**
	 * This method initializes maleRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getMaleRadioButton() {
		if (maleRadioButton == null) {
			maleRadioButton = new JRadioButton();
			maleRadioButton.setText(Locale.get("ParticularWindow.maleRadioButton"));
			maleRadioButton.setBounds(new Rectangle(474, 16, 71, 21));
			maleRadioButton.doClick();
		}
		return maleRadioButton;
	}

	/**
	 * This method initializes femaleRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getFemaleRadioButton() {
		if (femaleRadioButton == null) {
			femaleRadioButton = new JRadioButton();
			femaleRadioButton.setText(Locale.get("ParticularWindow.femaleRadioButton"));
			femaleRadioButton.setBounds(new Rectangle(547, 16, 68, 21));
		}
		return femaleRadioButton;
	}

	/**
	 * This method initializes nationalityComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getNationalityComboBox() {
		if (nationalityComboBox == null) {

			nationalityComboBox = new JComboBox(AddressController.countriesList().toArray());

			nationalityComboBox.setBounds(new Rectangle(115, 81, 191, 18));
		}
		return nationalityComboBox;
	}

	/**
	 * This method initializes thirdPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getThirdPanel() {
		if (thirdPanel == null) {
			cardLabel = new JLabel();
			cardLabel.setBounds(new Rectangle(21, 90, 66, 16));
			cardLabel.setText(Locale.get("ParticularWindow.cardLabel"));
			bankLabel = new JLabel();
			bankLabel.setBounds(new Rectangle(21, 59, 66, 16));
			bankLabel.setText(Locale.get("ParticularWindow.bankLabel"));
			voucherNumLabel = new JLabel();
			voucherNumLabel.setBounds(new Rectangle(252, 28, 73, 16));
			voucherNumLabel.setText(Locale.get("ParticularWindow.voucherNumLabel"));
			cardNumLabel = new JLabel();
			cardNumLabel.setBounds(new Rectangle(252, 90, 73, 16));
			cardNumLabel.setText(Locale.get("ParticularWindow.cardNumLabel"));
			accountNumLabel = new JLabel();
			accountNumLabel.setBounds(new Rectangle(252, 59, 73, 16));
			accountNumLabel.setText(Locale.get("ParticularWindow.accountNumLabel"));
			payModeLabel = new JLabel();
			payModeLabel.setBounds(new Rectangle(21, 28, 66, 16));
			payModeLabel.setText(Locale.get("ParticularWindow.payModeLabel"));
			thirdPanel = new JPanel();
			thirdPanel.setLayout(null);
			thirdPanel.setSize(new Dimension(686, 346));
			thirdPanel.add(payModeLabel, null);
			thirdPanel.add(getPayModeComboBox(), null);
			thirdPanel.add(accountNumLabel, null);
			thirdPanel.add(getAccountNumTextField(), null);
			thirdPanel.add(cardNumLabel, null);
			thirdPanel.add(getCardNumTextField(), null);
			thirdPanel.add(voucherNumLabel, null);
			thirdPanel.add(getVoucherNumTextField(), null);
			thirdPanel.add(bankLabel, null);
			thirdPanel.add(getBankComboBox(), null);
			thirdPanel.add(cardLabel, null);
			thirdPanel.add(getCardComboBox(), null);
		}
		return thirdPanel;
	}

	/**
	 * This method initializes payModeComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getPayModeComboBox() {
		if (payModeComboBox == null) {
			payModeComboBox = new JComboBox();
			payModeComboBox.setBounds(new Rectangle(96, 27, 146, 19));
			payModeComboBox.addItem(Locale.get("ParticularWindow.payModeComboBox.item0"));
			payModeComboBox.addItem(Locale.get("ParticularWindow.payModeComboBox.item1"));
			payModeComboBox.addItem(Locale.get("ParticularWindow.payModeComboBox.item2"));
			payModeComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					switch (payModeComboBox.getSelectedIndex()) {

					case 0:						
						getBankComboBox().setEnabled(true);
						getAccountNumTextField().setEnabled(true);
						getCardComboBox().setEnabled(false);						
						getCardNumTextField().setEnabled(false);
						//getCardNumTextField().setBackground(new Color(248,248,248));
						getVoucherNumTextField().setEnabled(false);
						break;
					case 1:
						getCardComboBox().setEnabled(true);
						getCardNumTextField().setEnabled(true);
						//getCardNumTextField().setBackground(Color.WHITE);
						getBankComboBox().setEnabled(false);
						getAccountNumTextField().setEnabled(false);						
						getVoucherNumTextField().setEnabled(false);
						break;
					case 2:
						getVoucherNumTextField().setEnabled(true);
						getBankComboBox().setEnabled(false);
						getAccountNumTextField().setEnabled(false);
						getCardComboBox().setEnabled(false);
						getCardNumTextField().setEnabled(false);
						//getCardNumTextField().setBackground(new Color(248,248,248));
						break;

					}
				}
			});


		}
		return payModeComboBox;
	}

	/**
	 * This method initializes accountNumTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getAccountNumTextField() {
		if (accountNumTextField == null) {
			accountNumTextField = new JTextField();
			accountNumTextField.setHorizontalAlignment(JTextField.TRAILING);
			accountNumTextField.setBounds(new Rectangle(332, 59, 326, 20));
		}
		return accountNumTextField;
	}

	/**
	 * This method initializes cardNumTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getCardNumTextField() {
		if (cardNumTextField == null) {
			Document integerDocument = new IntegerDocument(16);
			cardNumTextField = new JTextField(integerDocument,"",16);							
			cardNumTextField.setHorizontalAlignment(JTextField.TRAILING);				
			cardNumTextField.setBounds(new Rectangle(332, 90, 326, 20));				
		}
		return cardNumTextField;
	}

	/**
	 * This method initializes voucherNumTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getVoucherNumTextField() {
		if (voucherNumTextField == null) {
			voucherNumTextField = new JTextField();
			voucherNumTextField.setHorizontalAlignment(JTextField.TRAILING);
			voucherNumTextField.setBounds(new Rectangle(332, 28, 326, 20));
		}
		return voucherNumTextField;
	}

	/**
	 * This method initializes bankComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getBankComboBox() {
		if (bankComboBox == null) {
			bankComboBox = new JComboBox((new BankListAdapter()).load());
			bankComboBox.setBounds(new Rectangle(96, 59, 146, 19));						
		}
		return bankComboBox;
	}

	/**
	 * This method initializes cardComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCardComboBox() {
		if (cardComboBox == null) {
			cardComboBox = new JComboBox((new CardListAdapter()).load());
			cardComboBox.setBounds(new Rectangle(96, 90, 146, 19));;
		}
		return cardComboBox;
	}

	/**
	 * This method initializes companyComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getCompanyComboBox() {
		if (companyComboBox == null) {
			Vector companies = (new CompanyListAdapter()).load();
			companies.insertElementAt(new TextItem(new Long(0),""), 0);
			companyComboBox = new JComboBox(companies);
			companyComboBox.setBounds(new Rectangle(94, 187, 282, 18));
		}
		return companyComboBox;
	}

	/**
	 * This method initializes jobTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJobTextField() {
		if (jobTextField == null) {
			jobTextField = new JTextField();
			jobTextField.setBounds(new Rectangle(476, 187, 198, 18));
		}
		return jobTextField;
	}

	/**
	 * This method initializes clientTypeComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getClientTypeComboBox() {
		if (clientTypeComboBox == null) {
			clientTypeComboBox = new JComboBox();
			clientTypeComboBox.setBounds(new Rectangle(606, 15, 68, 16));
			clientTypeComboBox.addItem(Locale.get("ParticularWindow.clientTypeComboBox.item0"));
			clientTypeComboBox.addItem(Locale.get("ParticularWindow.clientTypeComboBox.item1"));
		}
		return clientTypeComboBox;
	}

	public void clean() {

		getInfoPanel().setInfoText(getInfoPanel().getInfoText());
		getJTabbedPane().setSelectedIndex(0);
		getNameTextField().setText("");
		getBornTextField().setText(DateOperations.calendarToText(Calendar.getInstance()));
		if (getClientTypeComboBox().getItemCount() != 0) getClientTypeComboBox().setSelectedIndex(0);
		getFirstSurnameTextField().setText("");
		getSecondSurnameTextField().setText("");
		if (getCountryComboBox().getItemCount() != 0) getCountryComboBox().setSelectedIndex(0);
		if (getProvinceComboBox().getItemCount() != 0) getProvinceComboBox().setSelectedIndex(0);
		if (getLocalityComboBox().getItemCount() != 0) getLocalityComboBox().setSelectedIndex(0);
		getStreetTextField().setText("");
		getDwellingPlaceTextField().setText("");
		if (getCompanyComboBox().getItemCount() != 0) getCompanyComboBox().setSelectedIndex(0);
		getJobTextField().setText("");
		getPhone1TextField().setText("");
		getPhone2TextField().setText("");
		getFaxTextField().setText("");
		getEmailTextField().setText("");
		getWebTextField().setText("");
		getJTextArea().setText("");
		if (getDocumentTypeComboBox().getItemCount()!= 0) getDocumentTypeComboBox().setSelectedIndex(0);
		getDocumentNumberTextField().setText("");
		getExpeditionTextField().setText(DateOperations.calendarToText(Calendar.getInstance()));
		getExpirationTextField().setText(DateOperations.calendarToText(Calendar.getInstance()));
		if (getNationalityComboBox().getItemCount() != 0) getNationalityComboBox().setSelectedIndex(0);
		getMaleRadioButton().doClick();
		if (getPayModeComboBox().getItemCount() !=0) getPayModeComboBox().setSelectedIndex(0);
		getAccountNumTextField().setText("");
		if (getBankComboBox().getItemCount() != 0) getBankComboBox().setSelectedIndex(0);
		getCardNumTextField().setText("");
		if (getCardComboBox().getItemCount() != 0) getCardComboBox().setSelectedIndex(0);
		getVoucherNumTextField().setText("");
		getNameTextField().setBorder(UIManager.getBorder("TextField.border"));
		getFirstSurnameTextField().setBorder(UIManager.getBorder("TextField.border"));
		getSecondSurnameTextField().setBorder(UIManager.getBorder("TextField.border"));
		getDocumentNumberTextField().setBorder(UIManager.getBorder("TextField.border"));
		getExpeditionTextField().setBorder(UIManager.getBorder("TextField.border"));
		getExpirationTextField().setBorder(UIManager.getBorder("TextField.border"));
		getCountryComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getProvinceComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getLocalityComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getCompanyComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getBankComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getCardComboBox().setBorder(UIManager.getBorder("ComboBox.border"));

	}

	public void fill(HashMap fields) {

		getNameTextField().setText((String) fields.get("name"));
		getBornTextField().setText(DateOperations.calendarToText((Calendar) fields.get("bornDate")));

		if (((String) fields.get("clientType")).equals("VIP")) getClientTypeComboBox().setSelectedIndex(1);		
		if (((String) fields.get("clientType")).equals("Normal")) getClientTypeComboBox().setSelectedIndex(0);

		getFirstSurnameTextField().setText((String) fields.get("firstSurname"));
		getSecondSurnameTextField().setText((String) fields.get("secondSurname"));		
		getCountryComboBox().setSelectedItem(AddressController.addressCountry((Long) fields.get("address")));
		getProvinceComboBox().setSelectedItem(AddressController.addressProvince((Long) fields.get("address")));
		getLocalityComboBox().setSelectedItem(AddressController.addressLocality((Long) fields.get("address")));
		getStreetTextField().setText((String) fields.get("street"));
		getDwellingPlaceTextField().setText((String) fields.get("dwellingPlace"));

		for (int i=0; i<getCompanyComboBox().getItemCount(); i++) {
			TextItem item = (TextItem) getCompanyComboBox().getItemAt(i); 
			if ((item.getId()).equals(((TextItem) fields.get("company")).getId())) {
				getCompanyComboBox().setSelectedIndex(i);
			}
		}

		getJobTextField().setText((String) fields.get("job"));
		getPhone1TextField().setText((String) fields.get("phone1"));
		getPhone2TextField().setText((String) fields.get("phone2"));
		getFaxTextField().setText((String) fields.get("fax"));
		getEmailTextField().setText((String) fields.get("email"));
		getWebTextField().setText((String) fields.get("web"));
		getJTextArea().setText((String) fields.get("notes"));

		if (((String) fields.get("documentType")).equals("DNI")) getDocumentTypeComboBox().setSelectedIndex(0);
		if (((String) fields.get("documentType")).equals("Pasaporte")) getDocumentTypeComboBox().setSelectedIndex(1);

		getDocumentNumberTextField().setText((String) fields.get("documentNumber"));		
		getExpeditionTextField().setText(DateOperations.calendarToText((Calendar) fields.get("expeditionDate")));
		getExpirationTextField().setText(DateOperations.calendarToText((Calendar) fields.get("expirationDate")));
		getNationalityComboBox().setSelectedItem((String) fields.get("nationality"));

		String sex = ((String) fields.get("sex"));
		if (sex.equals("H")) getMaleRadioButton().setSelected(true);
		else getFemaleRadioButton().setSelected(true);

		if (((String) fields.get("payMode")).equals("Contado")) getPayModeComboBox().setSelectedIndex(0);
		if (((String) fields.get("payMode")).equals("Tarxeta")) getPayModeComboBox().setSelectedIndex(1);
		if (((String) fields.get("payMode")).equals("Bono")) getPayModeComboBox().setSelectedIndex(2);

		getAccountNumTextField().setText((String) fields.get("accountNumber"));

		for (int i=0; i<getBankComboBox().getItemCount(); i++) {
			ImageItem item = (ImageItem) getBankComboBox().getItemAt(i); 
			if ((item.getId()).equals(((ImageItem) fields.get("bank")).getId())) {
				getBankComboBox().setSelectedIndex(i);
			}
		}

		getCardNumTextField().setText((String) fields.get("cardNumber"));

		for (int i=0; i<getCardComboBox().getItemCount(); i++) {
			ImageItem item = (ImageItem) getCardComboBox().getItemAt(i); 
			if ((item.getId()).equals(((ImageItem) fields.get("card")).getId())) {
				getCardComboBox().setSelectedIndex(i);
			}
		}

		getVoucherNumTextField().setText((String) fields.get("voucherCode"));		

	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new Rectangle(93, 273, 579, 51));
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
		}
		return jTextArea;
	}

	private boolean inputErrors() {

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("name")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.name")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getNameTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("firstSurname")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.firstSurname")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getFirstSurnameTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("secondSurname")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.secondSurname")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getSecondSurnameTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("documentNumber")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.documentNumber")+ "</html>");
				getJTabbedPane().setSelectedIndex(1);
				getDocumentNumberTextField().setBorder(new LineBorder(Color.red, 2));			
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("interval")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.documentDates")+ "</html>");
				getJTabbedPane().setSelectedIndex(1);
				getExpeditionTextField().setBorder(new LineBorder(Color.red, 2));
				getExpirationTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("address")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.address")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getCountryComboBox().setBorder(new LineBorder(Color.red, 2));
				getProvinceComboBox().setBorder(new LineBorder(Color.red, 2));
				getLocalityComboBox().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("company")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.company")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getCompanyComboBox().setBorder(new LineBorder(Color.red, 2));			
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("bank")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.bank")+ "</html>");
				getJTabbedPane().setSelectedIndex(2);
				getBankComboBox().setBorder(new LineBorder(Color.red, 2));			
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("card")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.card")+ "</html>");
				getJTabbedPane().setSelectedIndex(2);
				getCardComboBox().setBorder(new LineBorder(Color.red, 2));			
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

		}

		return false;

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
