package gz.cyberbrain.cyberhotel.view.swing.reception;

import gz.cyberbrain.cyberhotel.controller.AgencyListAdapter;
import gz.cyberbrain.cyberhotel.controller.CompanyListAdapter;
import gz.cyberbrain.cyberhotel.controller.ParticularListAdapter;
import gz.cyberbrain.cyberhotel.view.swing.start.MainWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.Payable;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JLabel;
import java.awt.Rectangle;
import java.awt.event.WindowEvent;

import javax.swing.JScrollPane;
import javax.swing.JButton;
import javax.swing.JList;

public class PayerWindow extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private Payable observer = null;

	private JPanel jContentPane = null;

	private JLabel particularsLabel = null;

	private JLabel agenciesLabel = null;

	private JLabel companiesLabel = null;

	private JScrollPane particularsScrollPane = null;

	private JScrollPane agenciesScrollPane = null;

	private JScrollPane companiesScrollPane = null;

	private JButton acceptButton = null;

	private JButton cancelButton = null;

	private JList particularsList = null;

	private JList agenciesList = null;

	private JList companiesList = null;

	/**
	 * @param owner
	 */
	public PayerWindow() {
		super(MainWindow.getInstance(), true);
		initialize();
	}

	public Payable getObserver() {
		return observer;
	}
	
	public void setObserver(Payable observer) {
		this.observer = observer;
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(611, 445);
		this.setContentPane(getJContentPane());
		this.setTitle(Locale.get("PayerWindow.title"));
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.addWindowListener(new java.awt.event.WindowListener() {

			public void windowActivated(WindowEvent arg0) {}

			public void windowClosed(WindowEvent arg0) {
				clean();
			}

			public void windowClosing(WindowEvent arg0) {}

			public void windowDeactivated(WindowEvent arg0) {}

			public void windowDeiconified(WindowEvent arg0) {}

			public void windowIconified(WindowEvent arg0) {}

			public void windowOpened(WindowEvent arg0) {}

		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			companiesLabel = new JLabel();
			companiesLabel.setBounds(new Rectangle(477, 30, 65, 16));
			companiesLabel.setText(Locale.get("PayerWindow.companiesLabel"));
			agenciesLabel = new JLabel();
			agenciesLabel.setBounds(new Rectangle(275, 30, 65, 16));
			agenciesLabel.setText(Locale.get("PayerWindow.agenciesLabel"));
			particularsLabel = new JLabel();
			particularsLabel.setBounds(new Rectangle(69, 30, 88, 16));
			particularsLabel.setText(Locale.get("PayerWindow.particularsLabel"));
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(particularsLabel, null);
			jContentPane.add(agenciesLabel, null);
			jContentPane.add(companiesLabel, null);
			jContentPane.add(getParticularsScrollPane(), null);
			jContentPane.add(getAgenciesScrollPane(), null);
			jContentPane.add(getCompaniesScrollPane(), null);
			jContentPane.add(getAcceptButton(), null);
			jContentPane.add(getCancelButton(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes particularsScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getParticularsScrollPane() {
		if (particularsScrollPane == null) {
			particularsScrollPane = new JScrollPane();
			particularsScrollPane.setBounds(new Rectangle(23, 49, 178, 330));
			particularsScrollPane.setViewportView(getParticularsList());
		}
		return particularsScrollPane;
	}

	/**
	 * This method initializes agenciesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getAgenciesScrollPane() {
		if (agenciesScrollPane == null) {
			agenciesScrollPane = new JScrollPane();
			agenciesScrollPane.setBounds(new Rectangle(217, 49, 178, 330));
			agenciesScrollPane.setViewportView(getAgenciesList());
		}
		return agenciesScrollPane;
	}

	/**
	 * This method initializes companiesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getCompaniesScrollPane() {
		if (companiesScrollPane == null) {
			companiesScrollPane = new JScrollPane();
			companiesScrollPane.setBounds(new Rectangle(409, 49, 178, 330));
			companiesScrollPane.setViewportView(getCompaniesList());
		}
		return companiesScrollPane;
	}

	/**
	 * This method initializes acceptButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAcceptButton() {
		if (acceptButton == null) {
			acceptButton = new JButton();
			acceptButton.setText(Locale.get("PayerWindow.acceptButton"));
			acceptButton.setBounds(new Rectangle(433, 387, 77, 18));
			acceptButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					TextItem payer = null;

					if (!getParticularsList().isSelectionEmpty()) payer = (TextItem) getParticularsList().getSelectedValue();
					if (!getAgenciesList().isSelectionEmpty()) payer = (TextItem) getAgenciesList().getSelectedValue();
					if (!getCompaniesList().isSelectionEmpty()) payer = (TextItem) getCompaniesList().getSelectedValue();

					if (payer != null) getObserver().setPayer(payer.getId(), payer.getText());

					dispose();

				}
			});

		}
		return acceptButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Locale.get("PayerWindow.cancelButton"));
			cancelButton.setBounds(new Rectangle(515, 387, 77, 18));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					clean();
					dispose();

				}
			});

		}
		return cancelButton;
	}

	/**
	 * This method initializes particularsList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getParticularsList() {
		if (particularsList == null) {
			particularsList = new JList((new ParticularListAdapter()).load());
			particularsList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
			{
				public void valueChanged(javax.swing.event.ListSelectionEvent evt)
				{

					getAgenciesList().clearSelection();
					getCompaniesList().clearSelection();					

				}
			});

		}
		return particularsList;
	}

	/**
	 * This method initializes agenciesList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getAgenciesList() {
		if (agenciesList == null) {
			agenciesList = new JList((new AgencyListAdapter()).load());
			agenciesList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
			{
				public void valueChanged(javax.swing.event.ListSelectionEvent evt)
				{

					getParticularsList().clearSelection();
					getCompaniesList().clearSelection();


				}
			});

		}
		return agenciesList;
	}

	/**
	 * This method initializes companiesList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getCompaniesList() {
		if (companiesList == null) {
			companiesList = new JList((new CompanyListAdapter()).load());
			companiesList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
			{
				public void valueChanged(javax.swing.event.ListSelectionEvent evt)
				{

					getParticularsList().clearSelection();
					getAgenciesList().clearSelection();

				}
			});

		}
		return companiesList;
	}

	public void clean() {

		getParticularsList().clearSelection();
		getAgenciesList().clearSelection();
		getCompaniesList().clearSelection();		

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
