package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.awt.Color;
import java.awt.Graphics;

import org.jdesktop.swingx.calendar.JXMonthView;

public class JYMonthView extends JXMonthView {

	private static final long serialVersionUID = 1L;
	private Color _selectionBackground = null;

	 /**
     * Returns the selected background color.
     *
     * @return the selected background color.
     */
    public Color getSelectionBackground() {
        return _selectionBackground;
    }

    /**
     * Sets the selected background color to <code>c</code>.  The default color
     * is <code>138, 173, 209 (Blue-ish)</code>
     *
     * @param c Selected background.
     */
    public void setSelectionBackground(Color c) {
    	_selectionBackground = c;
    } 
	/**
     * Paint the background for a selected day.  The default is a filled
     * rectangle in the in the component's background color.
     *
     * @param g Graphics object to paint to.
     * @param x x-coordinate of upper left corner.
     * @param y y-coordinate of upper left corner.
     * @param width width of bounding box for the day.
     * @param height height of bounding box for the day.
     */
    protected void paintSelectedDayBackground(Graphics g, int x, int y,
            int width, int height) {
        g.setColor(getSelectionBackground());
        g.fillRect(x, y, width, height);
    }
}
