package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import gz.cyberbrain.cyberhotel.controller.ListAdapter;
import gz.cyberbrain.cyberhotel.view.swing.ToolsWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import java.util.HashMap;
import java.util.Vector;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JButton;
import java.awt.Rectangle;
import java.io.Serializable;

public class ToolsPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private Vector items = new Vector();  //  @jve:decl-index=0:
	private int current = 0;
	private int numItems = 0;
	private Object currentItem = null;  //  @jve:decl-index=0:
	private JButton previousButton = null;
	private JButton nextButton = null;
	private ToolsWindow observer = null;
	private ListAdapter adapter = null;
	private JButton addButton = null;
	private JButton editButton = null;
	private JButton delButton = null;
	private JButton cancelButton = null;

	public ToolsPanel(ToolsWindow observer, ListAdapter adapter) {
		super();
		this.observer = observer;
		this.adapter = adapter;
		this.items = adapter.load();		
		initialize();
	}

	private void initialize() {
		current = 0;
		numItems = items.size();

		this.setLayout(null);

		this.setSize(new Dimension(494, 50));

		this.add(getPreviousButton(), null);
		this.add(getNextButton(), null);
		this.add(getAddButton(), null);
		this.add(getEditButton(), null);
		this.add(getDelButton(), null);
		this.add(getCancelButton(), null);

		getAddButton().setEnabled(true);		
		getCancelButton().setEnabled(false);

		if (items.size() != 0) {			
			getObserver().fill(getAdapter().find(((ListItem) items.elementAt(0)).getId()));
			currentItem = items.elementAt(0);
			getEditButton().setEnabled(true);
			getDelButton().setEnabled(true);
			getPreviousButton().setEnabled(true);
			getNextButton().setEnabled(true);
		} else {
			currentItem = null;
			getObserver().clean();
			getEditButton().setEnabled(false);
			getDelButton().setEnabled(false);
			getPreviousButton().setEnabled(false);
			getNextButton().setEnabled(false);
		}

	}

	public void reset() {

		current = 0;

		items = adapter.load();

		numItems = items.size();

		getAddButton().setEnabled(true);		
		getCancelButton().setEnabled(false);

		if (items.size() != 0) {
			getObserver().fill(getAdapter().find(((ListItem) items.elementAt(0)).getId()));
			currentItem = items.elementAt(0);
			getEditButton().setEnabled(true);
			getDelButton().setEnabled(true);
			getPreviousButton().setEnabled(true);
			getNextButton().setEnabled(true);
		} else {
			currentItem = null;
			getObserver().clean();
			getEditButton().setEnabled(false);
			getDelButton().setEnabled(false);
			getPreviousButton().setEnabled(false);
			getNextButton().setEnabled(false);
		}

	}

	public void current() {

		items = adapter.load();

		getAddButton().setEnabled(true);		
		getCancelButton().setEnabled(false);

		if (items.size() != 0) {

			if (items.size() == numItems) {
				getObserver().fill(getAdapter().find(((ListItem) items.elementAt(current)).getId()));
				getObserver().setId((Serializable) ((HashMap) getAdapter().find(((ListItem) items.elementAt(current)).getId())).get("id"));
			}
			else { //An Add operation was done.
				getObserver().fill(getAdapter().find(((ListItem) items.elementAt(items.size()- 1)).getId()));
				getObserver().setId((Serializable) ((HashMap) getAdapter().find(((ListItem) items.elementAt(items.size()- 1)).getId())).get("id"));
				current = items.size() - 1;
				numItems = items.size();
			}

			getEditButton().setEnabled(true);
			getDelButton().setEnabled(true);
			getPreviousButton().setEnabled(true);
			getNextButton().setEnabled(true);

			currentItem = items.elementAt(current);

		} else {
			current = 0;
			numItems = 0;
			getEditButton().setEnabled(false);
			getDelButton().setEnabled(false);
			getPreviousButton().setEnabled(false);
			getNextButton().setEnabled(false);
		}

	}

	public boolean next() {
		boolean next = false;

		if (current < items.size() - 1) { 					
			current++;			
			currentItem = items.elementAt(current);
			next = true;
		}

		return next;
	}

	public boolean previous() {
		boolean previous = false;

		if (current > 0) {
			current--;
			currentItem = items.elementAt(current);
			previous = true;
		}

		return previous;
	}

	public ListAdapter getAdapter() {
		return adapter;
	}

	public ToolsWindow getObserver() {
		return observer;
	}

	public Object getCurrentItem() {
		return currentItem;
	}

	/**
	 * This method initializes previousButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getPreviousButton() {
		if (previousButton == null) {
			previousButton = new JButton("<");
			previousButton.setBounds(new Rectangle(200, 0, 50, 50));
			previousButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getObserver().cleanErrors();
					if (previous())
						getObserver().fill(getAdapter().find(((ListItem) currentItem).getId()));
					else
						Toolkit.getDefaultToolkit().beep();
				}
			});
		}
		return previousButton;
	}

	/**
	 * This method initializes nextButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getNextButton() {
		if (nextButton == null) {
			nextButton = new JButton(">");
			nextButton.setBounds(new Rectangle(250, 0, 50, 50));
			nextButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getObserver().cleanErrors();
					if (next())
						getObserver().fill(getAdapter().find(((ListItem) currentItem).getId()));
					else
						Toolkit.getDefaultToolkit().beep();
				}
			});
		}
		return nextButton;
	}

	/**
	 * This method initializes addButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAddButton() {
		if (addButton == null) {
			addButton = new JButton("+");
			addButton.setBounds(new Rectangle(0, 0, 50, 50));
			addButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getObserver().cleanErrors();
					getObserver().unlock();
					getObserver().clean();
					getObserver().setAdapter(getAdapter().getCreator());

					addButton.setEnabled(false);
					getEditButton().setEnabled(false);
					getDelButton().setEnabled(false);
					getPreviousButton().setEnabled(false);
					getNextButton().setEnabled(false);					
					getCancelButton().setEnabled(true);
				}
			});
		}
		return addButton;
	}

	/**
	 * This method initializes editButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getEditButton() {
		if (editButton == null) {
			editButton = new JButton("#");
			editButton.setBounds(new Rectangle(50, 0, 50, 50));
			editButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					try {

						getObserver().setAdapter(getAdapter().getUpdater());
						getObserver().cleanErrors();
						getObserver().unlock();				

						getAddButton().setEnabled(false);
						editButton.setEnabled(false);
						getDelButton().setEnabled(false);
						getPreviousButton().setEnabled(false);
						getNextButton().setEnabled(false);					
						getCancelButton().setEnabled(true);

					} catch (UnsupportedOperationException e1) {
						getObserver().showErrors();
					}
				}
			});
		}
		return editButton;
	}

	/**
	 * This method initializes delButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getDelButton() {
		if (delButton == null) {
			delButton = new JButton("-");
			delButton.setBounds(new Rectangle(100, 0, 50, 50));
			delButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {								

					try {

						Object[] options = {Locale.get("JOptionPane.Yes"), Locale.get("JOptionPane.No")};
						int n = JOptionPane.showOptionDialog(getObserver(),
								Locale.get("JOptionPane.ToolsPanel.delButton.message"),
								Locale.get("JOptionPane.ToolsPanel.delButton.title"),
								JOptionPane.YES_NO_OPTION,
								JOptionPane.INFORMATION_MESSAGE,
								null,
								options,
								options[0]);

						if (n == JOptionPane.YES_OPTION) {													

							getAdapter().delete(getObserver().getId());
							
							if (!getObserver().showErrors()) {
								getObserver().clean();
								items = adapter.load();
								numItems = items.size();											

								if (items.size() == 1) {
									getObserver().fill(getAdapter().find(((ListItem) items.elementAt(0)).getId()));
									getObserver().update();
								}

								else if (previous()) { 						
									getObserver().fill(getAdapter().find(((ListItem) currentItem).getId()));
									getObserver().update();
								}

								else if (next()) { 
									getObserver().fill(getAdapter().find(((ListItem) currentItem).getId()));
									getObserver().update();
								}

								else {
								
									getObserver().update();
									getObserver().setAdapter(getAdapter().getCreator());

									getEditButton().setEnabled(false);
									getDelButton().setEnabled(false);
									getPreviousButton().setEnabled(false);
									getNextButton().setEnabled(false);

									current = 0;
									currentItem = null;
								}												

							}

						} 																	

					} catch (UnsupportedOperationException e1) {
						getObserver().showErrors();
					}

				}
			});
		}
		return delButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton("X");
			cancelButton.setBounds(new Rectangle(350, 0, 50, 50));
			cancelButton.setEnabled(false);
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					getObserver().lock();
					if (currentItem != null) {
						getObserver().clean();
						getObserver().fill(getAdapter().find(((ListItem) currentItem).getId()));
						getAddButton().setEnabled(true);
						getEditButton().setEnabled(true);
						getDelButton().setEnabled(true);
						getPreviousButton().setEnabled(true);
						getNextButton().setEnabled(true);
						cancelButton.setEnabled(false);
					}
					else {
						getObserver().clean();
						getAddButton().setEnabled(true);
						getEditButton().setEnabled(false);
						getDelButton().setEnabled(false);
						getPreviousButton().setEnabled(false);
						getNextButton().setEnabled(false);
						cancelButton.setEnabled(false);
					}

				}
			});
		}
		return cancelButton;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
